function out1 = conver(action, in1,in2);
% conver		- new->old format data converter
% UNITRET MODULE
%--------------------------------------------------------------------------------
% Written by I.Kagan								 
% (c) 2001-2002	 								 
%										 
% *******************************						 
% * Last modification: 19.11.02 *						 
% *******************************						 
% Short Description:								 
% Converts new system data files to old system - UNITRET compatible format
% See unitret\DATAM.PHD for description of the old format					 
% NOTE: SET the current "new" system format - see RUNMODENAME below	
% See also UNITRET, UNISPIKEDATF, READBWSHAPES.			 
%--------------------------------------------------------------------------------

% Notes:
% 999 	- obsolete in new format
% ? 	- not yet implemented
% !	- should be filled in 

if nargin<1,
        clear global;
        h=get(0,'Children');
        close(h);
        fclose('all');
        action='start';
        matlabpath = path;
        act_dir = cd;
        if isempty(findstr(lower(matlabpath),lower(act_dir))),
                path(matlabpath,act_dir);
        end;
	if exist('tmp.mat')
                delete tmp.mat;
        end; 
end;
ud = get(0,'Userdata');

global RUNMODENAME ETD VERBOSE
if isempty(ud),
	RUNMODENAME = 'system 3.0';	% default, always set to the most recent version

else
	RUNMODENAME = ['system ' sprintf('%.1f', ud(187))];
end

ETD = 1;
VERBOSE = 0;

if strcmp(action,'no etd')
	RUNMODENAME(1:6) = 'no etd';
	ETD = 0;
	
	h=get(0,'Children');
        close(h);
        fclose('all');
        matlabpath = path;
        act_dir = cd;
        if isempty(findstr(lower(matlabpath),lower(act_dir))),
                path(matlabpath,act_dir);
        end;
    
	if exist('tmp.mat')
                delete tmp.mat;
        end;
	action='start'; 	
end

% try %%% ERROR HANDLING

if strcmp(action,'start'),
	div = '_'; % file name divider

	if 0 % *** here is old version, based on eyetracker file
	
	if (nargin == 2)		% batch mode
		etfilename = in1;
		batch = 1;
	else
		batch = 0;
		[etfilename, pathname] = uigetfile('*.etd' , 'Select Eye Tracker File', .4, .4);
		if etfilename == 0, return; end;
		cd(pathname);
	end
	fnamebase = etfilename(1:length(etfilename)-4);
	
	[fid, message] = fopen([etfilename],'r');

	if ~fid,
		disp(message);
		out1 = message;
		return
	end

	

	% read bw spike file
	spikefilename = [fnamebase,'.f32'];

	end % *** of old version

	if (nargin == 2)		% batch mode
		bwfilename = in1;
		batch = 1;
	else
		batch = 0;
		[bwfilename, pathname] = uigetfile('*.f32' , 'Select BW file', .4, .4);
		if bwfilename == 0, return; end;
		cd(pathname);
	end
	fnamebase = bwfilename(1:length(bwfilename)-4);
	
	% read etd file
	if ETD
		[fid, message] = fopen([fnamebase(1:4) div fnamebase(6:8) '.etd'],'r');
	end

	if fid<=0,
		disp([fnamebase '.etd: ' message]);
		out1 = [fnamebase '.etd: ' message];
		return
	end

	% read bw spike file

	if 0
		
	elseif 0
		fnamebase(5) = '1';
	elseif 0
		fnamebase(5) = '2';
	end

	[numsets, totalsweeps, totalspikes, data] = unispikedatf(bwfilename);
		
	if isempty(numsets)
		return
	end

	trial	= 0;
	rep	= 0;
	nread	= 0;
	inds	= [];
	if ETD
		[temp, nfloats] = fread(fid, inf, 'float');	% read number of floats in file
		fseek(fid,0,-1);				% rewind the file
	else
		nfloats = totalsweeps;
	end


	while nread < nfloats,

		trial = trial + 1;
		if ETD	
			ind   	= fread(fid, 1, 'float');
			npts  	= fread(fid, 1, 'float');
			dur   	= fread(fid, 1, 'float');
			srate 	= fread(fid, 1, 'float');
			rel 	= fread(fid, 1, 'float');
			xdata	= fread(fid, npts, 'float'); 	 
			ydata	= fread(fid, npts, 'float');

			nread 	= nread + 5 + 2*length(xdata);
			dur 	= (1000/srate)*npts;
		else
			ind   	= trial;
			
			dur   	= 5000;
			srate 	= 200;
			rel 	= 1;
			xdata	= zeros(1,srate*(dur/1000)); 	 
			ydata	= zeros(1,srate*(dur/1000));
			
			npts  	= length(xdata);
			nread 	= trial;
		end

		inds = [inds ind];
		rep = length( find(ind == inds) );
                
                if VERBOSE
			disp([ind trial rep])
		end
                
		etdata( ind, rep ).trial = trial;
		etdata( ind, rep ).ind = ind;
		etdata( ind, rep ).npts = npts;
		etdata( ind, rep ).dur = dur;
		etdata( ind, rep ).srate = srate;
		etdata( ind, rep ).rel = rel;
		etdata( ind, rep ).xdata = xdata;
		etdata( ind, rep ).ydata = ydata;	


	end

        if ETD
		fclose(fid);
	end
        
	% check if ind do not begin from 1 - then reshape etdata
	% (this may occur if record mode started on other than 1st StimulusGrid row, or batch has not been completed)
	minind = min(inds);
	if 0 & (minind~=1)
	        temp_etdata = etdata;
	        ii = 1;
	        for i = 1:ind
	                emptyind = 1;
	                for j = 1:rep
	                        if ~(isempty(etdata(i,j).trial))
	                                emptyind = 0;
	                        end
	                end
	                if ~emptyind
	                        temp_etdata(ii,:) = etdata(i,:);			
				ii = ii+1;
	                end

	        end
	   	etdata = temp_etdata;     
	end  
        
        
   	warnmsg = '';
	if (trial-1) == totalsweeps,
		warnmsg = ['Warning: last eyetracker trial was discarded... '];
		disp(warnmsg);
		trial = trial-1;
	elseif trial ~= totalsweeps,
		errormsg = ['Number of eyetracker trials (',num2str(trial),') is different from number of BW sweeps (',num2str(totalsweeps),'). Exiting...'];
		disp(errormsg);
		if ~batch,
			errordlg(errormsg);
		end
		out1 = errormsg;
		return
	end

	% delay of RP2 is about 6.7174 ms (41 sample)
	RP2Delay = 1000/6103.515625*41;

	ntrials = trial;
	% general parameters (for entire file):

	% stab	=	data(1).stim(6);
	% vd 	=	data(1).stim(14)/10;


	newfn = [fnamebase,'.a',strrep(sprintf('%2d',ntrials),char(32),'0')];
	fnlen = length(newfn);
	newfilename = newfn(1:min(fnlen,14)); % 14 char
	
	if exist([newfilename])
		message = ['file ',newfilename,' already exists. Exiting.'];
		disp(message);
		out1 = message;
		return;
	end;


	% shapes
	shapemsg = '';
	shape_success = 0;
	
	if exist([newfilename(1:end-3) 'txt'])==2,
		[shape_success, shape_struct] = readbwshapes([newfilename(1:end-3) 'txt']);
		if shape_success,
			shapemsg = '(Shapes included)';
		end
	end
	
	

	
	% ---------- FILE HEADER BLOCK --------------------
        Ver                     =	0;
        FileLength              =	999;
        FileHeaderLength        =	2+4+2+2+2+2+2+ntrials*4;
        GlobSpecBlockNum        =	1;
        TrialsNum               =	ntrials;
        CommLength              =	9;	
        GlobSpecBlockLength     =	128;
        TrialBegin              =	999;

        % ---------- FILE SPECIFICATION  BLOCK ------------
	FileName = blanks(14);
        FileName(1:length(newfilename))		=    	newfilename; 	% 14 char
        FileDate		=	[strrep(date,'-','') ' ']; 	% 10 char
        RunModName              =    	RUNMODENAME;	% 10 char
        VideoFramePeriod        =    	6.25;		% ! ms
        ViewDistance            =    	0;		% ! cm vd
        TimeFirstSample         =    	999;
        NumSamp2Frame           =    	999;
        HorizVisualFieldLoc     =    	0;		% ?
        VertVisualFieldLoc      =       0;		% ?
        HorizPosLED             =    	0;		% ?
        VertPosLED              =    	0;		% ?
        HorizEyePosGain         =    	1;		% !
        VertEyePosGain          =    	1;		% !
        EyetrackArbDef          =    	1;		% !
        EyetrackArbV0           =    	0;		% !
        Empty                   =    	999;
        LeftEdge                =    	0; 		% ?
        BottomEdge              =    	0;		% ?
        RightEdge               =    	0;		% ?
        TopEdge                 =    	0;		% ?
        StabFlag                =    	0;		% ! stab
        Empty                   =    	0;		% temporal type: flag
        Empty                   =   	0;		% spatial type: flag
        CompFlag                =    	2;
        DateTime                =    	'------------------';	% 18 char
        EyePer                  =    	1000/srate;	% ! ms
        SpikePer                =    	1;		% ! ms
        ShapePer                =    	1.5/40;		% ! ms
        FixationType		=    	0;		% ?

	% ---------- FILE COMMENT BLOCK -------------------
        Comments 		= 	'';
	save tmp


	[t, bwsi]  = sort(inds);
        nusc = length(unique(inds));		% number of unique stimulus conditions
        					% ^^^ THIS is problematic if we have different batches with different settings 
	trial = 0;
	nbatch = 1;
        
        n = 0;
        s = 1;
        
        % last_rep_taken = ones(1,nusc); % what if indexes do not start from one?
        last_rep_taken = ones(1,max(inds));
	for numset = 1:numsets,
                

		for sweep = 1:size(data(numset).sweep,2),
			trial = trial + 1;
			%subplot(ntrials, 1, trial)	

                        
                        % to select appropriate etdata, just move along not empty members of etdata array,
                        % in row order. Number of rows equal to maximal number of stimulus conditions across all batches
                        
                        
                        if 0	% start <zaglushka>
                                
                        % attempted new variant, but does not really work 
                        n = n+1;
                        if n>size(etdata,1)
                                n = 1;
                                s = s + 1;
                                if sweep==1
                                        nbatch = nbatch +1;
                                end
                                
                        elseif isempty(etdata(n,s).trial) 
                                while isempty(etdata(n,s).trial)
                                        n=n+1;
                                        if n>size(etdata,1)
                                                break;
                                        end
                                end
                                if n>size(etdata,1)
                                	n = 1;
                                	s = s + 1;
                                	if sweep==1
                                        	nbatch = nbatch +1;
                                        end
                                end
                                
                        end
                        
                        
                        
			% old (up to, and including some of, version 2.0) variant
			if numset <= nusc(nbatch),	% 1st batch, numset
						% corresponds to ind, sweep
						% to sequential number in
						% series of trials with this ind
				n = numset;
				s = sweep;
				lastsweep(nbatch,n) = max(lastsweep(nbatch,n), s);
			else
				n = numset - nusc(nbatch)*(nbatch-1);
				s = sweep+lastsweep(nbatch-1,n);
				lastsweep(nbatch,n) = max(lastsweep(nbatch,n), s);
                        end                
                        end	% end <zaglushka>
                        
                        % select etdata member - new variant
                        n = data(numset).stim(1);
                        s = last_rep_taken(n);

			if ~ETD % reshape etdata 
				% etdata(numset,sweep) = etdata(trial,1);	old version
				etdata(n,s) = etdata(trial,1);
			end

						
                        last_rep_taken(n) = last_rep_taken(n)+1;

			if VERBOSE
				disp([trial n s])
				% disp([data(numset).stim(1) numset sweep])
			end
                        
			SpkArrTime = data(numset).sweep(sweep).spikes;
                        if 0
                        figure
			plot((0:(1000/etdata(n,s).srate):(1000/etdata(n,s).srate)*etdata(n,s).npts-1)-RP2Delay, etdata(n,s).xdata,'Color',[0 .502 0]), hold on
			plot((0:(1000/etdata(n,s).srate):(1000/etdata(n,s).srate)*etdata(n,s).npts-1)-RP2Delay, etdata(n,s).ydata,'m'), hold on
			plot(SpkArrTime, ones(size(SpkArrTime)), '.'), hold on
			set(gca,'Xlim',[0 etdata(1,1).dur]);
			title(['tr. ', num2str(etdata(n,s).trial),' ind ',num2str(etdata(n,s).ind),' batch #',num2str(nbatch)] );
			Ylim = get(gca, 'Ylim');

			text(1,Ylim(2)-Ylim(2)/5,['batch # ',num2str(nbatch)])
			end

			% for each trial		
			chord = num2str(etdata(n,s).trial);	% chronological order

			% parse StimulusGrid

			% parameters that were not present in earlier versions:
				
			bgmode 	= 0;
			cont 	= 1;
			sph  	= 0;

			te_scale	= 999;
			te_frames	= 999;
			te_length	= 999;
			te_offset	= 999;
			te_file		= 999;
			
			if findstr(RUNMODENAME,'1.0')
	
				netsg	= 2; 	% number of parameters in StimulusGrid from EyeTracker 
				sid	= data(numset).stim(3);

				% meanwhile presets, then change to comply with old format
				ext = 0;
				vel = 0;
				osd = 0;
				tbs = 0;
				sf  = 0;
				tf  = 0;

				switch sid
	          		case 0 % background
					tt = 0; st = 0; 
				case 1 % static
					tt = 0; st = 0;			
				case 2 % flash
					tt = 2; st = 0; 
					ext = 0;
					vel = 0;
					osd	= data(numset).stim(20);
					tbs	= data(numset).stim(21);
	 			case 3 % sweep
					tt = 1; st = 0;
					ext	= data(numset).stim(20);
					vel	= data(numset).stim(21);
					osd	= ext/vel*1000;
					tbs	= 0;
				case 4 % wsine
					tt = 3; st = 6;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(20)/10;
					tf = data(numset).stim(21)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
				
	            	        end
				stab	= data(numset).stim(6);
				fr	= data(numset).stim(7);
				fg	= data(numset).stim(8);
				fb	= data(numset).stim(9);
				br	= data(numset).stim(10);
				bg	= data(numset).stim(11);
				bb	= data(numset).stim(12);
				vd	= data(numset).stim(14);

				xpos	= data(numset).stim(15);
				ypos	= data(numset).stim(16);
				xsize	= data(numset).stim(17);
				ysize	= data(numset).stim(18);
				tilt	= data(numset).stim(19);

			elseif(findstr(RUNMODENAME,'1.1'))

				netsg	= 5; 	% number of parameters in StimulusGrid from EyeTracker 
				sid	= data(numset).stim(netsg+1);

				% meanwhile presets, then change to comply with old format
				ext = 0;
				vel = 0;
				osd = 0;
				tbs = 0;
				sf  = 0;
				tf  = 0;

				switch sid
	          		case 0 % background
					tt = 0; st = 0; 
				case 1 % static
					tt = 0; st = 0;			
				case 2 % flash
					tt = 2; st = 0; 
					ext = 0;
					vel = 0;
					osd	= data(numset).stim(netsg+18);
					tbs	= data(numset).stim(netsg+19);
	 			case 3 % sweep
					tt = 1; st = 0;
					ext	= data(numset).stim(netsg+18);
					vel	= data(numset).stim(netsg+19);
					osd	= ext/vel*1000;
					tbs	= 0;
				case 4 % wsine
					tt = 3; st = 6;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+18)/10;
					tf = data(numset).stim(netsg+19)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
				
	            	        end
				
				stab	= data(numset).stim(netsg+4);				

				fr	= data(numset).stim(netsg+5);
				fg	= data(numset).stim(netsg+6);
				fb	= data(numset).stim(netsg+7);
				br	= data(numset).stim(netsg+8);
				bg	= data(numset).stim(netsg+9);
				bb	= data(numset).stim(netsg+10);

				vd	= data(numset).stim(netsg+12);

				xpos	= data(numset).stim(netsg+13);
				ypos	= data(numset).stim(netsg+14);
				xsize	= data(numset).stim(netsg+15);
				ysize	= data(numset).stim(netsg+16);
				tilt	= data(numset).stim(netsg+17);

			elseif(findstr(RUNMODENAME,'1.2'))

				netsg	= 5; 	% number of parameters in StimulusGrid from EyeTracker 
				sid	= data(numset).stim(netsg+1);

				% meanwhile presets, then change to comply with old format
				ext = 0;
				vel = 0;
				osd = 0;
				tbs = 0;
				sf  = 0;
				tf  = 0;

				switch sid
	          		case 0 % background
					tt = 0; st = 0; 
				case 1 % static
					tt = 0; st = 0;			
				case 2 % flash
					tt = 2; st = 0; 
					ext = 0;
					vel = 0;
					osd	= data(numset).stim(netsg+20);
					tbs	= data(numset).stim(netsg+21);
	 			case 3 % sweep
					tt = 1; st = 0;
					ext	= data(numset).stim(netsg+20);
					vel	= data(numset).stim(netsg+21);
					osd	= ext/vel*1000;
					tbs	= 0;
				case 4 % wsine
					tt = 3; st = 6;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+20)/10;
					tf = data(numset).stim(netsg+21)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+22);			
				case 5 % csine sine
					tt = 3; st = 10; % to comply with old format
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+20)/10;
					tf = data(numset).stim(netsg+21)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+22);
				case 6 % csine square
					tt = 3; st = 7; % to comply with old format
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+20)/10;
					tf = data(numset).stim(netsg+21)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+22);
				case 7 % csine ramp
					tt = 3; st = 11; 
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+20)/10;
					tf = data(numset).stim(netsg+21)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+22);
				case 8 % fwsine
					tt = 3; st = 12;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+20)/10;
					tf = data(numset).stim(netsg+21)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+22);
					gdur	= data(numset).stim(netsg+23);
					gint	= data(numset).stim(netsg+24);				
				case 9 % wsquare
					tt = 3; st = 13;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+20)/10;
					tf = data(numset).stim(netsg+21)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+22);
				case 10 % sqsweep (square wave sweep)
					tt = 1; st = 14;
					ext	= data(numset).stim(netsg+20);
					vel	= data(numset).stim(netsg+21);
					sf = data(numset).stim(netsg+22)/10;
					tf = data(numset).stim(netsg+23)/10;
					sph	= data(numset).stim(netsg+24);
					osd	= ext/vel*1000;
					tbs	= 0;
				
				
	            	        end

				stab	= data(numset).stim(netsg+4);				

				fr	= data(numset).stim(netsg+5);
				fg	= data(numset).stim(netsg+6);
				fb	= data(numset).stim(netsg+7);
				br	= data(numset).stim(netsg+8);
				bg	= data(numset).stim(netsg+9);
				bb	= data(numset).stim(netsg+10);

				vd	= data(numset).stim(netsg+12);
				bgmode  = data(numset).stim(netsg+13);

				if bgmode==1, % mean
					br	= fr/2;
					bg	= fg/2;
					bb	= fb/2;
				end	

				xpos	= data(numset).stim(netsg+14);
				ypos	= data(numset).stim(netsg+15);
				xsize	= data(numset).stim(netsg+16);
				ysize	= data(numset).stim(netsg+17);
				tilt	= data(numset).stim(netsg+18);
				cont 	= data(numset).stim(netsg+19)/100;

			elseif(findstr(RUNMODENAME,'2.0'))
				netsg	= 5; 	% number of parameters in StimulusGrid from EyeTracker 
				
				stab	= data(numset).stim(netsg+1);
				vd	= data(numset).stim(netsg+2);
				br	= data(numset).stim(netsg+3);
				bg	= data(numset).stim(netsg+4);
				bb	= data(numset).stim(netsg+5);
				bgmode  = data(numset).stim(netsg+6);
				ns	= data(numset).stim(netsg+7);

				sn	= data(numset).stim(netsg+8);
				sid	= data(numset).stim(netsg+9);				
				st	= data(numset).stim(netsg+10);
				tt	= data(numset).stim(netsg+11);

				fr	= data(numset).stim(netsg+12);
				fg	= data(numset).stim(netsg+13);
				fb	= data(numset).stim(netsg+14);
				if bgmode==1, % mean
					br	= fr/2;
					bg	= fg/2;
					bb	= fb/2;
				end

				xpos	= data(numset).stim(netsg+15);
				ypos	= data(numset).stim(netsg+16);
				xsize	= data(numset).stim(netsg+17);
				ysize	= data(numset).stim(netsg+18);
				tilt	= data(numset).stim(netsg+19);
				cont 	= data(numset).stim(netsg+20)/100;

				ext = 0;
				vel = 0;
				osd = 0;
				tbs = 0;
				sf  = 0;
				tf  = 0;
				sph = 0;

				switch sid
	          		case 0 % background
					tt = 0; st = 0; 
				case 1 % static
					tt = 0; st = 0;			
				case 2 % flash
					tt = 2; st = 0; 
					ext = 0;
					vel = 0;
					osd	= data(numset).stim(netsg+21);
					tbs	= data(numset).stim(netsg+22);
	 			case 3 % sweep
					tt = 1; st = 0;
					ext	= data(numset).stim(netsg+21);
					vel	= data(numset).stim(netsg+22);
					osd	= ext/vel*1000;
					tbs	= 0;
				case 4 % wsine
					tt = 3; st = 6;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+21)/10;
					tf = data(numset).stim(netsg+22)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+23);			
				case 5 % csine sine
					tt = 3; st = 10; % to comply with old format
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+21)/10;
					tf = data(numset).stim(netsg+22)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+23);
				case 6 % csine square
					tt = 3; st = 7; % to comply with old format
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+21)/10;
					tf = data(numset).stim(netsg+22)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+23);
				case 7 % csine ramp
					tt = 3; st = 11; 
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+21)/10;
					tf = data(numset).stim(netsg+22)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+23);
				case 8 % fwsine
					tt = 3; st = 12;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+21)/10;
					tf = data(numset).stim(netsg+22)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+23);
					gdur	= data(numset).stim(netsg+24);
					gint	= data(numset).stim(netsg+25);				
				case 9 % wsquare
					tt = 3; st = 13;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(netsg+21)/10;
					tf = data(numset).stim(netsg+22)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(netsg+23);
				case 10 % sqsweep (square wave sweep)
					tt = 1; st = 14;
					ext	= data(numset).stim(netsg+21);
					vel	= data(numset).stim(netsg+22);
					sf = data(numset).stim(netsg+23)/10;
					tf = data(numset).stim(netsg+24)/10;
					sph	= data(numset).stim(netsg+25);
					osd	= ext/vel*1000;
					tbs	= 0;

				case 11 % ssine
					tt = 1; st = 8;
					disp('No two stimluli ability yet!!!');
					% requires two stimuli
	            	        end				

			elseif(findstr(RUNMODENAME,'2.1'))
				netsg	= 5; 	% number of parameters in StimulusGrid from EyeTracker 
				
				stab	= data(numset).stim(netsg+1);
				vd	= data(numset).stim(netsg+2);
				br	= data(numset).stim(netsg+3);
				bg	= data(numset).stim(netsg+4);
				bb	= data(numset).stim(netsg+5);
				bgmode  = data(numset).stim(netsg+6);
				ns	= data(numset).stim(netsg+7);

				sn	= data(numset).stim(netsg+8);
				sid	= data(numset).stim(netsg+9);				
				st	= data(numset).stim(netsg+10);
				tt	= data(numset).stim(netsg+11);

				fr	= data(numset).stim(netsg+12);
				fg	= data(numset).stim(netsg+13);
				fb	= data(numset).stim(netsg+14);
				initime  = data(numset).stim(netsg+15);
				holdtime = data(numset).stim(netsg+16);
				finaltime= data(numset).stim(netsg+17);


				if bgmode==1, % mean
					br	= fr/2;
					bg	= fg/2;
					bb	= fb/2;
				end

				xpos	= data(numset).stim(netsg+18);
				ypos	= data(numset).stim(netsg+19);
				xsize	= data(numset).stim(netsg+20);
				ysize	= data(numset).stim(netsg+21);
				tilt	= data(numset).stim(netsg+22);
				cont 	= data(numset).stim(netsg+23)/100;

				varoffset = netsg + 23; 

				ext = 0;
				vel = 0;
				osd = 0;
				tbs = 0;
				sf  = 0;
				tf  = 0;
				sph = 0;


				switch sid
	          		case 0 % background
					tt = 0; st = 0; 
				case 1 % static
					tt = 0; st = 0;			
				case 2 % flash
					tt = 2; st = 0; 
					ext = 0;
					vel = 0;
					% first comes off (tbs), then on (osd)
					% but currently marker is plotted always osd-tbd,
					% therefore we interchange tbs and osd
					tbs	= data(numset).stim(varoffset+1);
					osd	= data(numset).stim(varoffset+2);
	 			case 3 % sweep
					tt = 1; st = 0;
					ext	= data(numset).stim(varoffset+1);
					vel	= data(numset).stim(varoffset+2);
					osd	= ext/vel*1000;
					tbs	= 0;
				case 4 % wsine
					tt = 3; st = 6;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);			
				case 5 % csine sine
					tt = 3; st = 10; % to comply with old format
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
				case 6 % csine square
					tt = 3; st = 7; % to comply with old format
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
				case 7 % csine ramp
					tt = 3; st = 11; 
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
				case 8 % fwsine
					tt = 3; st = 12;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
					gdur	= data(numset).stim(varoffset+4);
					gint	= data(numset).stim(varoffset+5);				
				case 9 % wsquare
					tt = 3; st = 13;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
				case 10 % sqsweep (square wave sweep)
					tt = 1; st = 14;
					ext	= data(numset).stim(varoffset+1);
					vel	= data(numset).stim(varoffset+2);
					sf = data(numset).stim(varoffset+3)/10;
					tf = data(numset).stim(varoffset+4)/10;
					sph	= data(numset).stim(varoffset+5);
					osd	= ext/vel*1000;
					tbs	= 0;

				case 11 % ssine
					tt = 1; st = 8;
					disp('No two stimluli ability yet!!!');
					% requires two stimuli
				end
				
			elseif(findstr(RUNMODENAME,'3.0'))
				netsg	= 5; 	% number of parameters in StimulusGrid from EyeTracker 
				
				stab	= data(numset).stim(netsg+1);
				vd	= data(numset).stim(netsg+2);
				br	= data(numset).stim(netsg+3);
				bg	= data(numset).stim(netsg+4);
				bb	= data(numset).stim(netsg+5);
				bgmode  = data(numset).stim(netsg+6);
				ns	= data(numset).stim(netsg+7);

				sn	= data(numset).stim(netsg+8);
				sid	= data(numset).stim(netsg+9);				
				st	= data(numset).stim(netsg+10);
				tt	= data(numset).stim(netsg+11);

				fr	= data(numset).stim(netsg+12);
				fg	= data(numset).stim(netsg+13);
				fb	= data(numset).stim(netsg+14);
				initime  = data(numset).stim(netsg+15);

				te_scale	= data(numset).stim(netsg+16);
				te_frames	= data(numset).stim(netsg+17);
				te_length	= data(numset).stim(netsg+18);
				te_offset	= data(numset).stim(netsg+19);
				te_file		= data(numset).stim(netsg+20);
			
				if bgmode==1, % mean
					br	= fr/2;
					bg	= fg/2;
					bb	= fb/2;
				end

				xpos	= data(numset).stim(netsg+21);
				ypos	= data(numset).stim(netsg+22);
				xsize	= data(numset).stim(netsg+23);
				ysize	= data(numset).stim(netsg+24);
				tilt	= data(numset).stim(netsg+25);
				cont 	= data(numset).stim(netsg+26)/100;

				varoffset = netsg + 26; 

				ext = 0;
				vel = 0;
				osd = 0;
				tbs = 0;
				sf  = 0;
				tf  = 0;
				sph = 0;


				switch sid
	          		case 0 % background
					tt = 0; st = 0; 
				case 1 % static
					tt = 0; st = 0;			
				case 2 % flash
					tt = 2; st = 0; 
					ext = 0;
					vel = 0;
					% first comes off (tbs), then on (osd)
					% but currently marker is plotted always osd-tbd,
					% therefore we interchange tbs and osd
					tbs	= data(numset).stim(varoffset+1);
					osd	= data(numset).stim(varoffset+2);
	 			case 3 % sweep
					tt = 1; st = 0;
					ext	= data(numset).stim(varoffset+1);
					vel	= data(numset).stim(varoffset+2);
					osd	= ext/vel*1000;
					tbs	= 0;
				case 4 % wsine
					tt = 3; st = 6;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);			
				case 5 % csine sine
					tt = 3; st = 10; % to comply with old format
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
				case 6 % csine square
					tt = 3; st = 7; % to comply with old format
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
				case 7 % csine ramp
					tt = 3; st = 11; 
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
				case 8 % fwsine
					tt = 3; st = 12;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
					gdur	= data(numset).stim(varoffset+4);
					gint	= data(numset).stim(varoffset+5);				
				case 9 % wsquare
					tt = 3; st = 13;
					ext = 0;
					vel = 0;
					sf = data(numset).stim(varoffset+1)/10;
					tf = data(numset).stim(varoffset+2)/10;
					osd 	= 1000/tf;
					tbs 	= osd;
					sph	= data(numset).stim(varoffset+3);
				case 10 % sqsweep (square wave sweep)
					tt = 1; st = 14;
					ext	= data(numset).stim(varoffset+1);
					vel	= data(numset).stim(varoffset+2);
					sf = data(numset).stim(varoffset+3)/10;
					tf = data(numset).stim(varoffset+4)/10;
					sph	= data(numset).stim(varoffset+5);
					osd	= ext/vel*1000;
					tbs	= 0;

				case 11 % ssine
					tt = 1; st = 8;
					disp('No two stimluli ability yet!!!');
					% requires two stimuli
				end
				
			else
				disp(['No such version yet! (' RUNMODENAME ')']);
				return
			

			end % of if for version

			% fix stimulus duration to interger multiple of frame period
			osd = osd - mod(osd,VideoFramePeriod);
			tbs = tbs - mod(tbs,VideoFramePeriod);

			% fill in general parameters here, although they should be same for all trials in a file
			ViewDistance 	= vd;
			StabFlag	= stab;
			

		        %--------- TRIAL HEADER 	-------------------                               
		        SerNum                  =    trial;		% !
		        TrialHeaderLength       =    20;
		        ParamBlockNum           =    1;
		        DataBlockNum            =    5;	
		        ParamBlockLength        =    174;
		        DataBlockLength         =    [1 1 1 1 1];

			%--------- TRIAL PARAMETERS 	------------------- 
			TrialTime = blanks(10);	     
		        TrialTime(1:length(chord))   = chord;		% 10 char
		        TrialDuration           =    etdata(n,s).dur;	% ! ms
		        OneStimDuration         =    osd;		% ! ms
		        TimeBetweenStim         =    tbs;		% ! ms
		        Tilt                    =    tilt;		% ! deg
		        RadialBoxSize           =    xsize;		% ! minarc
		        PerpenBoxSize           =    ysize;		% ! minarc
		        XStartPos               =    xpos;		% ! minarc
		        YStartPos               =    ypos;		% ! minarc
		        ExtentStimMotion        =    ext;		% ! minarc
		        StimVelocity            =    vel;		% ! minarc/s
		        ColorCode               =    bgmode;		
		        FgrRedInt               =    fr;		% !
		        FgrGreenInt             =    fg;		% !
		        FgrBlueInt              =    fb;		% !
		        BckgrRedInt             =    br;		% !
		        BckgrGreenInt           =    bg;		% !
		        BckgrBlueInt            =    bb;		% !
		        ElemRedInt              =    999;
		        ElemGreenInt            =    999;
		        ElemBlueInt             =    999;
		        %               * * Applicable to Sinusoid & Gabor:  * *
		        SpatialFreq             =    sf;		% !
		        PhRed                   =    sph;			% !
		        PhGreen                 =    sph;			% ! same as Red
		        PhBlue                  =    sph;			% ! same as Red
		        StnDiv                  =    999;
		        Contrast                =    cont;			% !
		        TempFreq                =    tf;		% !
		        %            * * Applicable to REGULAR: * *
		        ElemLength              =    999;
		        ElemWidth               =    999;
		        SpLengthDirec           =    999;
		        SpWidthDirect           =    999;
		        %            * * Additional timing values: * *
		        StartEyeData            =    0;			% !
		        StartSpikeData          =    0;			% !
		        EndSpikeData            =    (EyePer*etdata(n,s).npts);			% !
		        TimeCode                =    999;
		        StimTempType            =    tt;		% !
		        StimSpatType            =    st;		% !
		        EyeChoice               =    3;			% !
		        %            * * Additional positioning info: * *
			%	     * * version 3.0 -- TE parameters * *
		        SweepFract              =    te_scale;
		        TrigTech                =    te_frames;
		        SpikeTrig               =    te_length;
		        ShapeTrig               =    te_offset;
		        ShapeHist               =    te_file;
		        ShapeLen                =    40;		% !
		        ShapeTrigValue		=    10;		% ! 
			%	     * * Different fixation targets: * *
		        FirstStimTime 	 	=    0;
		        AngleFix 		=    0;
		        FixChangeTime 	 	=    0;
		        SteadyFixTime 	 	=    0;
		        FixNoChangeTime 	=    0;
		        TotalFixDistance 	=    0;
		        FixFraction 		=    0;
			
			RawHorizEyePos          =    etdata(n,s).xdata;
			RawVertEyePos           =    etdata(n,s).ydata;
			RawSpikeArrTime         =    SpkArrTime;
			
			RawShapeArrTime        	=    [];
			ShapeArrTime 		=    [];
			ShapeAmp            	=    [];

			if shape_success,
				if ~(isempty(shape_struct(numset).sweep(sweep).data)),
					RawShapeArrTime        	=    shape_struct(numset).sweep(sweep).data(:,1);
					ShapeArrTime 		=    RawShapeArrTime/ShapePer;
					ShapeAmp            	=    shape_struct(numset).sweep(sweep).data(:,3:end);
					ShapeAmp		=    reshape(ShapeAmp',1,size(ShapeAmp,1)*size(ShapeAmp,2));
				end
			end
				
			save tmp
			
			conver('write_trial',newfilename);

        		if 0 %%%
			RawHorizEyePos          =    (fread(fid,DataBlockLength(1)/2,'short'))';
			HorizEyePos = (RawHorizEyePos - EyetrackArbV0.*ones(size(RawHorizEyePos)))./(HorizEyePosGain*EyetrackArbDef);
			RawVertEyePos           =    (fread(fid,DataBlockLength(2)/2,'short'))';
			VertEyePos = (RawVertEyePos - EyetrackArbV0.*ones(size(RawVertEyePos)))./(VertEyePosGain*EyetrackArbDef);
                        SpikeArrTime            =    (fread(fid,DataBlockLength(3)/4,'long'))';
                        SpikeArrTime = SpikePer.*SpikeArrTime;	

			RawShapeArrTime         =    (fread(fid,DataBlockLength(4)/4,'long'))';
			ShapeArrTime = ShapePer.*RawShapeArrTime;
			ShapeAmp            	=    (fread(fid,DataBlockLength(5)/2,'short'))';
			end %%%
		end
	end
delete tmp.mat ;
str = [newfilename,sprintf('\t'),'created successfully. ' shapemsg ' ' warnmsg];
disp(str);
out1 = str;
if ~batch
	% unitret;
end

elseif(strcmp(action,'write_trial')),
	
	fname = in1;
	
	load tmp
	AppendOK = exist(fname);		% return 2 if file exists


	Comments = ['Converted from new format'];       
	CommLength = length(Comments);
	Separator = 'wwww';
 
        if AppendOK~=2,	% file not exists and should be created
                [fidtmp, message] = fopen(fname,'w');
                if(fidtmp<0), 
                        error(message);
                        return;
                end;

		% ---------- WRITING THE FILE HEADER BLOCK -----------------------
		fwrite(fidtmp,Ver,'ushort');
		FileLengthPos = ftell(fidtmp);
		fwrite(fidtmp,999,'long');
		FileHeaderLengthPos = 20;
		TrialsNum = 1;				% for one trial
		fwrite(fidtmp,[FileHeaderLengthPos,GlobSpecBlockNum,TrialsNum,...
		                CommLength,GlobSpecBlockLength],'ushort');

		TrialBeginPos = ftell(fidtmp);
		fwrite(fidtmp,998,'long');
		fwrite(fidtmp, Separator, 'char');

		%disp('FILE HEADER BLOCK WRITTEN.... OK');

		% ---------- WRITING THE FILE SPECIFICATION  BLOCK -----------------------

		fwrite(fidtmp,[FileName,FileDate,RunModName],'char');
		fwrite(fidtmp,[VideoFramePeriod,ViewDistance,TimeFirstSample],'float');
		fwrite(fidtmp,NumSamp2Frame,'ushort');
		fwrite(fidtmp,...
		        [HorizVisualFieldLoc,VertVisualFieldLoc,HorizPosLED,VertPosLED,...
		                HorizEyePosGain,VertEyePosGain,EyetrackArbDef],'float');
		fwrite(fidtmp,...
		        [EyetrackArbV0,Empty,LeftEdge,BottomEdge,RightEdge,TopEdge,StabFlag,...
		                Empty,Empty,CompFlag],'ushort');
		fwrite(fidtmp,DateTime,'char');
		fwrite(fidtmp,[EyePer,SpikePer,ShapePer],'float');

		if ~isnan(FixationType),
		        fwrite(fidtmp,FixationType,'ushort');
		end        

		fwrite(fidtmp, Separator, 'char');

		% ---------- WRITING THE FILE COMMENT  BLOCK -----------------------
		fwrite(fidtmp, Comments, 'char');
		fwrite(fidtmp, Separator, 'char');

	else	% file exists and should be read and write
		[fidtmp, message] = fopen(fname,'r+');
		if(fidtmp<0), 
		        error(message);
		        return;
		end;

		Ver                     =    fread(fidtmp, 1,'ushort');			%2
		FileLengthPos		=    ftell(fidtmp);
		FileLength              =    fread(fidtmp, 1,'long');			%+4
		FileHeaderLength        =    fread(fidtmp, 1,'ushort');       	 	%+2   
		GlobSpecBlockNum        =    fread(fidtmp, 1,'ushort');			%+2

		TrialsNum               =    fread(fidtmp, 1,'ushort');			%+2
		CommLength              =    fread(fidtmp, 1,'ushort');			%+2
		GlobSpecBlockLength     =    fread(fidtmp,GlobSpecBlockNum, 'ushort');	%+2

		TrialBegin              =    fread(fidtmp,TrialsNum,'long');		%+4*TrialsNum
		fseek(fidtmp, -(TrialsNum*4),0);			% all the beginnings of the file will be shifted
		fwrite(fidtmp, TrialBegin+4,'long'); 			% right shift for 4 bytes 

		TrialBeginPos 		=    ftell(fidtmp);
		fseek(fidtmp,TrialBeginPos,-1); %%% MATLAB BUGSSSSSSSS!!!

		RestData		=    fread(fidtmp);    

		fseek(fidtmp,10, -1); 
		fwrite(fidtmp,TrialsNum+1,'ushort'); 		% increment of TriaslsNum
		fseek(fidtmp,6, -1); 
		fwrite(fidtmp,FileHeaderLength+4,'ushort'); 	% increment of FileHeaderLength

		fseek(fidtmp,TrialBeginPos, -1); 
		fwrite(fidtmp,999,'long');  			% reserve the position for new TrialBegin;

		fwrite(fidtmp,RestData); 

	end;

	% ---------- WRITING THE TRIAL HEADER BLOCK --------------------------------

	% ----------------- UPDATE TRIAL BEGIN POSITION ----------------------------
	CurrentPos = ftell(fidtmp);
	fseek(fidtmp,TrialBeginPos,-1);
	fwrite(fidtmp,CurrentPos,'long');
	fseek(fidtmp,CurrentPos,-1);


	fwrite(fidtmp,[SerNum,TrialHeaderLength,ParamBlockNum,DataBlockNum,ParamBlockLength],'ushort');

	DataBlockLengthPos = ftell(fidtmp);
	for j=1:DataBlockNum,
		fwrite(fidtmp,999,'ushort');
	end;  
	fwrite(fidtmp, Separator, 'char');

	%--------- WRITING THE TRIAL PARAMETERS ------------------------------------
	fwrite(fidtmp, TrialTime, 'char');
	fwrite(fidtmp,...
	[TrialDuration,OneStimDuration,TimeBetweenStim,Tilt,RadialBoxSize,...
	        PerpenBoxSize,XStartPos,YStartPos,ExtentStimMotion],'ushort');
	fwrite(fidtmp,[StimVelocity,ColorCode],'short');
	fwrite(fidtmp,[FgrRedInt,FgrGreenInt,FgrBlueInt,BckgrRedInt,...
	        BckgrGreenInt,BckgrBlueInt,ElemRedInt,ElemGreenInt,ElemBlueInt,SpatialFreq],...
	'float');
	fwrite(fidtmp,[PhRed,PhGreen,PhBlue],'ushort');
	fwrite(fidtmp,[StnDiv,Contrast,TempFreq,ElemLength,ElemWidth,...
	        SpLengthDirec,SpWidthDirect,StartEyeData,StartSpikeData,EndSpikeData],...
	'float');

	fwrite(fidtmp,[TimeCode,StimTempType,StimSpatType,EyeChoice],'ushort');
	fwrite(fidtmp,SweepFract,'float');
	fwrite(fidtmp,TrigTech,'short');
	fwrite(fidtmp,[SpikeTrig,ShapeTrig,ShapeHist],'float');
	fwrite(fidtmp,[ShapeLen,ShapeTrigValue],'ushort');

	if ~isnan(FirstStimTime)
		fwrite(fidtmp,FirstStimTime,'short');
		fwrite(fidtmp,[AngleFix,FixChangeTime,SteadyFixTime,FixNoChangeTime,...
	                TotalFixDistance,FixFraction],'float');
	end

	fwrite(fidtmp, Separator, 'char');



	%--------- WRITING THE HORIZONTAL EYE POSITION ----------------------------------------

	fwrite(fidtmp,RawHorizEyePos,'float32');
	fwrite(fidtmp, Separator, 'char');
	%----------- WRITING THE VERTICAL EYE POSITION ---------------------------------------
	fwrite(fidtmp,RawVertEyePos,'float32');
	fwrite(fidtmp, Separator, 'char');

	% ------------ WRITING THE SPIKES DATA ------------------------------------------------
	fwrite(fidtmp,RawSpikeArrTime,'float32');
	fwrite(fidtmp, Separator, 'char');

	% ------------ WRITING THE SPIKE SHAPE TIMING DATA ------------------------------------------------
	fwrite(fidtmp,RawShapeArrTime,'float32');
	fwrite(fidtmp, Separator, 'char');

	% ------------ WRITING THE SPIKE SHAPE VALUES DATA ------------------------------------------------

	fwrite(fidtmp,ShapeAmp,'short');
	fwrite(fidtmp, Separator, 'char');


	% ------------ UPDATE DATA BLOCK LENGTH --------------------------------------------------
	CurrentPos = ftell(fidtmp);
	fseek(fidtmp,DataBlockLengthPos,-1);
	fwrite(fidtmp,...
	[4*length(RawHorizEyePos), 4*length(RawVertEyePos),...
	        4*length(RawSpikeArrTime), 4*length(RawShapeArrTime) 2*length(ShapeAmp)], 'ushort');
	fseek(fidtmp,CurrentPos,-1);
	%----------------- END WRITING OF TRIAL ---------------------------------------------

	%%%%%   

	% ------------ UPDATE FILE LENGTH POSITION--------------------------------------------------

	CurrentPos = ftell(fidtmp);
	fseek(fidtmp,FileLengthPos,-1);
	fwrite(fidtmp,CurrentPos,'long');
	fseek(fidtmp,CurrentPos,-1);

	% ------------ CLOSE TRIAL FILE --------------------------------------------------
	fclose(fidtmp);

	%--------------------------------------------------------------------------------------------------



end % of if action

% catch %%% ERROR HANDLING

% Now do the error handling
lasterror = lasterr;

if lasterror~='',
	ud(141) = 0;
        set(0,'Userdata',ud);		% exit batch mode, in case the error occured during the batch
	errordlg(lasterror,'Error Handling');
	lasterr('');
	out1 = 'Error occured during conversion!';
	disp(out1);
	return
end


% end %%% ERROR HANDLING
