function out1=cprint(action, in1,in2);
% cprint		- graphical representation and printout of experimental results
% not obligatory UNITRET MODULE
%--------------------------------------------------------------------------------
% written by A. Beylin, modified by Igor Kagan
% *******************************						 
% * Last modification: 25.05.99 *						 
% *******************************
%						 
% Short Description:
% Batch printing of trial data.
%
% Uses flist.exe								 
%	
% See also UNITRET.			 
%--------------------------------------------------------------------------------

  if nargin<1,
      clear global;
      h=get(0,'Children');
 %     close(h);
      fclose('all');
      action='start';
      open_win = get(0,'Children');
      delete(open_win);
  end;

global CPRINT_DAT WILDCARD

  if strcmp(action,'start'),
  % graphics initialization

% Default values: - Stored in ROOT object (0) as a UserData
   HPeriod = 0;
   MinHPeriod = 0;
   MaxHPeriod = 100;

   Trials = 6;
   MinTrials = 1;
   MaxTrials = 9;
   
   Ymin = -50;
   MinYmin = -400;
   MaxYmin = -5;

   Ymax = 50;
   MinYmax = 5;
   MaxYmax = 400;

   VisCont = 1;
   NoVisCont = 0;
   YesVisCont = 1;

   PrintOnFile = 3;		%0 - direct print, 1 - Postscript, 2 - HPIIP, 3-HPIII
   
   PrintShape  = 1;

   DrawShapeNum = 10;
   MinDrawShapeNum = 1;
   MaxDrawShapeNum = 500;

   ShapeAutoscale = 0;
   MinShapeAutoscale = 0;
   MaxShapeAutoscale = 1;

   set(0,'UserData', [HPeriod,  MinHPeriod, MaxHPeriod,... 
		Trials,       MinTrials,  MaxTrials,...
		Ymin,        MinYmin,    MaxYmin,...
		Ymax ,      MinYmax,    MaxYmax ,...
                 VisCont,   NoVisCont, YesVisCont ,...
                 PrintOnFile PrintShape DrawShapeNum MinDrawShapeNum MaxDrawShapeNum,...
                 ShapeAutoscale MinShapeAutoscale  MaxShapeAutoscale],...
                 'DefaultAxesFontName','Helvetica',...
		'DefaultFigureUnits','Normalized', 'DefaultAxesUnits','Normalized',...
                'DefaultFigureInvertHardcopy','off','DefaultTextFontSize',9, 'DefaultTextColor',...
                'k','DefaultFigureNumberTitle','off','DefaultFigurePaperType','usletter',...
                'DefaultFigureMenubar','none');
   
     Fig1 = figure('Color','c', 'Units','Normal','Position',[.01 .05 .4 .9],'Name',...
         'CPRINT-97','MenuBar','none','Number','off','DefaultTextFontWeight','demi',...
         'DefaultTextFontName','Helvetica');
         
    set(axes,'Position',[0 0 1 1],'visible','off');

     
     u1 = uimenu(Fig1,'Label','&File');
     u15 = uimenu(u1,'Label','&Group','Callback','cprint(''figdraw'')'); 
     u11 = uimenu(u1,'Label','&Add','Callback','cprint(''add'');');
     u16 = uimenu(u1,'Label','&Clear','Callback','cprint(''clear'')');
     
    u17 = uimenu(u1,'Label','Draw &Shape','Separator','on','callback',...
     ['curmen = get(gcf,''CurrentMenu'');DefValues=get(0,''UserData'');',...
      'if DefValues(17), set(curmen,''Checked'',''Off''); DefValues(17)=0;',...
      'else, set(curmen,''Checked'',''On'');DefValues(17)=1; end; set(0,''UserData'',DefValues);']);
     DefValues=get(0,'UserData');

       if DefValues(17),
       
         set(u17,'Checked','On');
       end;
     
 
     u12 = uimenu(u1,'Label','&Print to ...','Separator','on');

     
%---

     u120 = uimenu(u12,'Label','&Default printer','checked','off');
     u121 = uimenu(u12,'Label','&PS file','checked','off');
     u122 = uimenu(u12,'Label','&HP LaserJet IIP file','checked','off');     
     u123 = uimenu(u12,'Label','HP &LaserJet III file','checked','off');     

       if DefValues(16)==0,       
         set(u120, 'Checked','On');
       elseif  DefValues(16)==1,
         set(u121, 'Checked','On');
       elseif  DefValues(16)==2,
         set(u122, 'Checked','On');
       elseif  DefValues(16)==3,
         set(u123, 'Checked','On');
       end;
    
     set(u120,'UserData',[0,u121, u122 u123]);	%[printing flag = 0, PS file hand, HP  IIP file hand, HP  III file hand];
     set(u121,'UserData',[1,u120, u122 u123]);	%[printing flag = 1, printer hand, HP file hand, HP  III file hand];
     set(u122,'UserData',[2,u120, u121 u123]);	%[printing flag = 2, printer hand, PS file hand, HP  III file hand];
     set(u123,'UserData',[3,u120, u121 u122]);	%[printing flag = 2, printer hand, PS file hand, HP  III file hand];
     % printing flag = Defvalues(16): 0-printer, 1 - PS file, 2 -  HP IIP file hand, HP  III file hand

      cb = ['curmen = get(gcf,''CurrentMenu'');DefValues=get(0,''UserData'');',...
            'ud = get(curmen,''UserData''); set(curmen,''Checked'',''On'');',...
            'set(ud(2:4),''Checked'',''Off'');DefValues(16)=ud(1);',...
            ' set(0,''UserData'',DefValues);'];



     set([u120 u121 u122 u123],'Callback',cb);
     
       
 
%----




     u14 = uimenu(u1,'Label','P&rinter Setup...','Callback','print -dsetup;');       
      
     u13 = uimenu(u1,'Label','E&xit','Separator','on','Callback','cprint(''exit'')');

     u2 = uimenu(Fig1,'Label','&Display');
     u21 = uimenu(u2,'Label','&Setup','Callback','cprint(''setup'')');
     
% Definition of decorate objects

      uicontrol(Fig1,'Style','text','Position',[.25 .9 .5 .08],...
        'Units','normal','ForegroundColor','k',...
        'BackgroundColor','c','String','FILES:',...
        'HorizontalAlignment','center');

% Definition of control objects 

print_callback = ['global CPRINT_DAT; names = get(CPRINT_DAT(1),''UserData'');',...
                  'for namenum = 1:size(names,1), cprint(''print'',namenum); end; ',....
                  'if length(CPRINT_DAT) >1, delete(CPRINT_DAT(2));',...
                  'CPRINT_DAT(2) = []; end;'];


u3 = uicontrol(Fig1,'style','pushbutton','Position',[.6 .1 .3 .08],...
       'Units','normal','Callback',print_callback,'String','Print');


axis('off');
drawnow;
CPRINT_DAT(1) = Fig1;
%path initialization
p = path;
program_dir = cd;

      if isempty(findstr(lower(p),lower(program_dir))),
        path(p,program_dir);
      end;
set(gca,'UserData',program_dir);

%---------------------------------------------------------------------------------------------------------------------------------------------------------------     

   elseif(strcmp(action,'setup'))

    DefValues = get(0,'UserData');

      Fig1 = figure('Backingstore','off','Name','Display Setup','Color','w','Backingstore','off',...
		    'Units','Normal','Position',[.22 .4 .5 .6],'Resize','Off','Number','off');

       uicontrol(Fig1,'Style','text','Position',[.2 .91 .5 .08],...
	'Units','normal','ForegroundColor','m',...
	'BackgroundColor','w','String','Display Setup:',...
	'HorizontalAlignment','center');

	uicontrol(Fig1,'Style','text','Position',[.02 .85 .5 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',['Histogram, (', num2str(DefValues(2)), '...',...
							num2str(DefValues(3)),') ms'],'HorizontalAlignment','left');
	
	uicontrol(Fig1,'Style','frame','Position',[.56 .84 .15 .07],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k');

   u1 = uicontrol(Fig1,'Style','edit','Position',[.58 .85 .11 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',num2str(DefValues(1)),...
	'HorizontalAlignment','left','Callback','cprint(''update'',1);');
%-----------------  
	uicontrol(Fig1,'Style','text','Position',[.02 .77 .5 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',['Trials, (', num2str(DefValues(5)), '...',...
					num2str(DefValues(6)),')'],'HorizontalAlignment','left');
	
	uicontrol(Fig1,'Style','frame','Position',[.56 .76 .15 .07],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k');

   u2 = uicontrol(Fig1,'Style','edit','Position',[.58 .77 .11 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',num2str(DefValues(4)),...
	'Callback','cprint(''update'',4);');
%----------------

	uicontrol(Fig1,'Style','text','Position',[.02 .59 .5 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','b','String','Y Scale:','HorizontalAlignment','left');

%-----------------
	
	uicontrol(Fig1,'Style','text','Position',[.02 .51 .5 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',['From (',num2str(DefValues(8)),'...',...
						num2str(DefValues(9)),')'], 'HorizontalAlignment','left');

	
	uicontrol(Fig1,'Style','frame','Position',[.56 .50 .15 .07],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k');

   u3 = uicontrol(Fig1,'Style','edit','Position',[.58 .51 .11 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',num2str(DefValues(7)),...
	'Callback','cprint(''update'',7);');
%----------------------
	uicontrol(Fig1,'Style','text','Position',[.02 .43 .5 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',['To (',num2str(DefValues(11)),'...',...
	num2str(DefValues(12)),')'], 'HorizontalAlignment','left');

	
	uicontrol(Fig1,'Style','frame','Position',[.56 .42 .15 .07],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k');

   u4 = uicontrol(Fig1,'Style','edit','Position',[.58 .43 .11 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',num2str(DefValues(10)),...
	'Callback','cprint(''update'',10);');
%---------------------
	uicontrol(Fig1,'Style','text','Position',[.02 .35 .5 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',['Visual Control (',num2str(DefValues(14)),'/',...
	num2str(DefValues(15)),')'], 'HorizontalAlignment','left');

	
	uicontrol(Fig1,'Style','frame','Position',[.56 .34 .15 .07],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k');

   u5 = uicontrol(Fig1,'Style','edit','Position',[.58 .35 .11 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',num2str(DefValues(13)),...
	'Callback','cprint(''update'',13);');
%---------------------
	uicontrol(Fig1,'Style','text','Position',[.02 .27 .5 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String','Shapes number', 'HorizontalAlignment','left');

	
	uicontrol(Fig1,'Style','frame','Position',[.56 .26 .15 .07],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k');

   u6 = uicontrol(Fig1,'Style','edit','Position',[.58 .27 .11 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',num2str(DefValues(18)),...
	'Callback','cprint(''update'',18);');


%---------------------
	uicontrol(Fig1,'Style','text','Position',[.02 .19 .5 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',['Shape Autoscale (',num2str(DefValues(22)),'/',...
	num2str(DefValues(23)),')'], 'HorizontalAlignment','left');

	
	uicontrol(Fig1,'Style','frame','Position',[.56 .18 .15 .07],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k');

   u7 = uicontrol(Fig1,'Style','edit','Position',[.58 .19 .11 .05],...
	'Units','normalized','BackgroundColor','w',...
	'ForegroundColor','k','String',num2str(DefValues(21)),...
	'Callback','cprint(''update'',21);');


%---------------------------------------
     
     OK_button=uicontrol(Fig1,'Style','pushbutton','Position',[.75 .83 .22 .12],...
	'Units','Normalized','String','OK','Callback',['delete(',num2str(Fig1), '); cprint(''update'',0);']);

     cancel=uicontrol(Fig1,'Style','pushbutton','Position',[.75 .65 .22 .12],...
	'Units','Normalized','String','Cancel','Callback',['delete(',num2str(Fig1), '), return']);

%---------------------------------------------------------------------------------------------------------------
% CallBacks procedure for upper menu control objects

 elseif(strcmp(action,'add'))
     [filename, pathname] = uigetfile('*.*', 'File Choice', .2, .1);
    already = 0;              %<-- to avoid choosing again the same file
    com = ['cd ' pathname(1:length(pathname)-1),';']; 
    eval(com);

  if (filename),
     names = get(CPRINT_DAT(1),'UserData');
     numnames = size(names,1);
     if numnames >= 80,
        text(.05, .2, 'cannot print more than 80 files, sorry');
        return;
     else, 
        FullName = [pathname,filename];
        if ~isempty(names),
          for i=1:numnames,
              already = strcmp(deblank(FullName), deblank(names(i,:))) + already;
          end;
        end;
        if ~already
           if numnames < 40, shift=0; idx = numnames;
           else
             shift=0.56; idx = numnames-40;
           end;
           x = 0.1+shift; y =0.9-(idx+1)*.02;
           text(x,y,filename,'FontSize',7);
          if isempty(names),
           names = FullName;
          else,   
           names = str2mat(names, FullName);
          end;
           set(CPRINT_DAT(1),'UserData', names);
        end;
      end;
      cprint('add');
  end;
%------------------------------------------------------------------------
elseif(strcmp(action,'figdraw')),
    global WILDCARD
    figure('units','normal','position',[.1 .2 .6 .5],...
             'Backingstore','off','Name','File:','Color',[0.7529 0.8627 0.7529]);
    wildcard_text=uicontrol('Style','text','Position',[.05 .7 .3 .05],...
        'Units','normalized','BackgroundColor',[0.7529 0.8627 0.7529],...
        'ForegroundColor','b','String','Wildcard:',...
        'HorizontalAlignment','left');
   if isempty(WILDCARD),
      curdir=eval('cd');
   else
      curdir=WILDCARD;
   end
 
   wildfield=uicontrol('Style','edit','Position',[.05 .64 .7 .06],...
        'Units','normalized','String',curdir,'BackGroundColor',[1 1 .2],...
        'Callback','cprint(''getnames'');');

   exit_button = uicontrol('units','normal','pos',[.05 .005 .2 .07],'horiz',...
           'center','string','Exit','callback',...
           ['close(gcf); if exist(''flist.lst''), delete flist.lst; end; ']);

%--------------------------------------------------------------------------------     


elseif(strcmp(action, 'getnames')),
     global WILDCARD
     cur_dir = cd;
     kids = get(CPRINT_DAT(1),'Children');
     for i=1:length(kids),
        if(strcmp( (get(kids(i),'Type')),'axes')),
         prog_dir = get(kids(i),'UserData');
         cd(prog_dir);
         break;
        end;
     end;   
     ProgName = 'flist';
     ServFname = 'flist.lst';
     WildCard = get(gco,'String');
     WILDCARD = WildCard;

     sep=max(find(WildCard=='\'));
     pathname=WildCard(1:sep);    
     comand_line = ['!',ProgName,' ',WildCard,' ',ServFname,' &'];
     eval(comand_line);
     fid = fopen(ServFname,'rt');
     F = fread(fid);
     fclose(fid);
     cd(cur_dir);
     
     m = 1; n=1;
     for(i=1:length(F)),
       if(F(i) > 64 & F(i) < 91),
         F(i) = F(i)+32; end;
       if(F(i)==10), m = m+1;n = 1;
       else new_names(m,n) = F(i); n = n+1; end;
     end;
     new_names = setstr(new_names);
     
     close(gcf);
     if ~isempty(new_names),
      
       for (i=1:size(new_names,1)),
         full_names(i,:) = [pathname,new_names(i,:)];
       end;
       new_names = full_names;
       full_names = [];
       
       old_names = get(CPRINT_DAT(1),'UserData');

       if isempty(old_names),
         names = new_names;
       else, 
        for i=1:size(new_names,1),
          kk = findstr(deblank(lower(old_names)),deblank(lower(new_names(i,:))));
          if ~isempty(kk),
              old_names(kk,:) = [];
          end
        end;
        names = str2mat(old_names, new_names);
       end;
       numnames=size(names,1);
       cprint('clear');


       if numnames >80,
         text(.05, .2, 'cannot print more than 80 files, sorry');
         numnames = 80;
       end;      
       shift=0;
       for j=1:numnames,
           if j < 40, shift=0; idx = j;
           else
             shift=0.56; idx = j-40;
           end;
           x = 0.1+shift; y =0.9-(idx)*.02;

           pure_names = names(j,length(pathname)+1:size(names,2));
           text(x,y,pure_names,'FontSize',7);
       end;
              
       set(CPRINT_DAT(1),'UserData', names);
      end;
   
%------------------------------------------------------------------------
   elseif(strcmp(action,'print'))
          names = get(CPRINT_DAT(1),'UserData');
          DefValues = get(0,'UserData');
          filename = deblank(names(in1,:));     
          [fid, message] = fopen(filename,'rb');
          frame = 1;
          
          if(fid<0), 
             error(message);
          end;



% ---------- READING THE FILE HEADER BLOCK -----------------------

% Common for all actions

          blockSTART		  =    ftell(fid);
          fseek(fid,2+4, -1);
          FileHeaderLength        =    fread(fid, 1,'ushort');
          fseek(fid,blockSTART, -1);

          Ver                     =    cprint('InitRead',[fid, 1,blockSTART,FileHeaderLength],'ushort');
          FileLength              =    cprint('InitRead',[fid, 1,blockSTART,FileHeaderLength],'long');
          FileHeaderLength        =    cprint('InitRead',[fid, 1,blockSTART,FileHeaderLength],'ushort');
          SpecBlockNum            =    cprint('InitRead',[fid, 1,blockSTART,FileHeaderLength],'ushort');
          TrialsNum               =    cprint('InitRead',[fid, 1,blockSTART,FileHeaderLength],'ushort');
          CommLength              =    cprint('InitRead',[fid, 1,blockSTART,FileHeaderLength],'ushort');
          SpecBlockLength     =        cprint('InitRead',[fid, SpecBlockNum,blockSTART,FileHeaderLength],...
                                               'ushort');

          TrialBegin              =    cprint('InitRead',[fid, TrialsNum,blockSTART,FileHeaderLength],'long');

	  
	   if cprint('NoSeparator',fid)
	    strerr = ['FORMAT ERROR on fileheader: file ', filename, ' skipped'];
	    fclose(fid);
	    disp(strerr);
	    return;
	end;

%disp('FILE HEADER BLOCK .... OK');

%------------- AXIS POSITION PREPARATION--------------------------------
         % axis location calculations
   
          Trials2Screen = min(DefValues(4),TrialsNum);
          if Trials2Screen == 9,
                col = 3;
                row = 3;
             elseif Trials2Screen == 6,
                col = 2;
                row = 3;
             elseif Trials2Screen == 4,
                col = 2;
                row = 2;
             elseif Trials2Screen == 2,
                col = 1;
                row = 2;
             elseif Trials2Screen == 1,
                 col = 1;
                 row = 1;
             else
          	col = 2;     % default 6 graphs on screen, if somebody asks to draw 3,5,7 or 8 graphs
	        row = 3;
             end;
    
             wi = .05;                          % width of each interval between axises
             hi = .02;                           % higth of each interval between axises
             wt = .9;                            % width of field for axis
             ht = .35;                          % heigth of field for axis 
             if DefValues(17),
	        ht = .38;
                hbs = .17;
%                wbs = (1 - wi*(DefValues(4)+1))/DefValues(4);
                 wbs = (wt-(DefValues(4)-1)*wi)/DefValues(4);

                 for(i=0:DefValues(4)-1),
 	          rectshape(i+1,:) = [wi+i*(wbs+wi) .4 wbs hbs];
                 end;

             else
		ht = .55; 
             end;

             wb = (wt-(col-1)*wi)/col;   % x size for one subplot axis 
             hb = (ht-(row-1)*hi)/row;   % y ....

             for(numrow=0:row-1),
                for(numcol=0:col-1),
                   graphposition = numrow*col + numcol+1;
	          rect(graphposition,:) = [0+wi+numcol*(wb+wi) 1-(hi/2+hb+numrow*(hb+hi)) wb hb];
                end;
             end;

% ---------- READING THE FILE SPECIFICATION  BLOCK -----------------------
          blockSTART     	   =    ftell(fid);

          FileName                 =    (setstr(cprint('InitRead',[fid, 14,blockSTART,SpecBlockLength],'char')))';
          FileDate                 =    deblank((setstr(cprint('InitRead',[fid, 10,blockSTART,SpecBlockLength],'char')))');
          RunModName               =    (setstr(cprint('InitRead',[fid, 10,blockSTART,SpecBlockLength],'char')))';
          VideoFramePeriod         =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          ViewDistance             =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          TimeFirstSample          =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          NumSamp2Frame            =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          HorizVisualFieldLoc      =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          VertVisualFieldLoc       =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          HorizPosLED              =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          VertPosLED               =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          HorizEyePosGain          =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          VertEyePosGain           =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          EyetrackArbDef           =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          EyetrackArbV0            =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          Empty                    =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          LeftEdge                 =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          BottomEdge               =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          RightEdge                =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          TopEdge                  =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          StabFlag                 =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          Empty                    =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');    % temporal type: flag
          Empty                    =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');     % spatial type: flag
          CompFlag                 =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');
          DateTime                 =    (setstr(cprint('InitRead',[fid, 18,blockSTART,SpecBlockLength],'uchar')))';
          EyePer                   =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          SpikePer                 =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
          ShapePer                 =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'float');
	  FixationType		   =    cprint('InitRead',[fid, 1,blockSTART,SpecBlockLength],'ushort');


	if ~ShapePer,
	  ShapePer =  1000/10000;               %ms
	end;


%disp('FILE SPEC  BLOCK ...OK');

         if cprint('NoSeparator',fid)
            strerr = ['FORMAT ERROR on filespec: file ', filename, ' skipped'];
	    disp(strerr);
	    fclose(fid);
	    return;
	end;
      
% ---------- READING THE FILE COMMENT  BLOCK -----------------------
          blockSTART     	   =    ftell(fid);
          Comments                 =    (setstr(cprint('InitRead',[fid, CommLength,blockSTART,CommLength],'char')))';

	  if cprint('NoSeparator',fid)
	    strerr = ['FORMAT ERROR on comments: file ', filename, ' skipped'];
	    disp(strerr);
	    fclose(fid);
	    return;
	  end;
% disp('FILE COMMENT  BLOCK ...OK');

          % textout on the left panel:
 
   if DefValues(13), vis='on'; else, vis = 'off'; end;
                  if  (size(CPRINT_DAT,2) > 1 ),    % second member exists (pointer on graph figure)
	      if strcmp(get(CPRINT_DAT(2),'Type'),'figure'),
		 Fig2 = CPRINT_DAT(2);
%		 set(0,'CurrentFigure',Fig2);
%                                drawnow;
		 clf;
	       end;
       else,       
                       Fig2 = figure('Units','normal', 'Position',[0.005 0.04 .9 .8],...
		     'Backingstore','off','color','w','Name', 'Trials Graph','DefaultAxesXcolor','k',...
		     'DefaultAxesFontSize',9,'DefaultAxesDrawMode','fast','visible',vis,...
		     'DefaultAxesYColor','k', 'DefaultAxesFontName','Helvetica',...
		     'DefaultAxesYLim',[DefValues(7) DefValues(10)]);
                       CPRINT_DAT(2) = Fig2;
       end;

            graphposition = 1;

       SPIKES = zeros(TrialsNum,4);
       STIMULUS = zeros(1,4);
 
         % READING OF TRIAL DATA: 
            for tnum=1:TrialsNum, 
%               disp(sprintf('\a'));
%               fprintf('\a');

	        Status = fseek(fid, TrialBegin(tnum),-1);
	        if Status ~=0,
%	           error('File format error');
	           strerr = ['FORMAT ERROR on trial data: file ', filename, ' skipped'];
	           disp(strerr);
	           fclose(fid);
	           return;		  
	        end;

          %--------- READING THE TRIAL HEADER ----------------------------------------
	

          blockSTART		        =    ftell(fid);
          fseek(fid,blockSTART+2, -1);
          TrialHeaderLength             =    fread(fid, 1,'ushort');
          fseek(fid,blockSTART, -1);




               SerNum(tnum)             =    cprint('InitRead',[fid, 1,blockSTART,TrialHeaderLength],'ushort');
   	       TrialHeaderLength        =    cprint('InitRead',[fid, 1,blockSTART,TrialHeaderLength],'ushort');
	       ParamBlockNum            =    cprint('InitRead',[fid, 1,blockSTART,TrialHeaderLength],'ushort');
	       DataBlockNum             =    cprint('InitRead',[fid, 1,blockSTART,TrialHeaderLength],'ushort');
	       ParamBlockLength         =    (cprint('InitRead',[fid, ParamBlockNum, blockSTART,TrialHeaderLength],'ushort'))'; 
	       DataBlockLength          =    (cprint('InitRead',[fid, DataBlockNum, blockSTART,TrialHeaderLength],'ushort'))'; 

   	       if cprint('NoSeparator',fid)
	           strerr = ['FORMAT ERROR on trial header: file ', filename, ' skipped'];
	           disp(strerr);
	           fclose(fid);
	           return;		  
	      end;
% disp('COMMON TRIAL DATA ...OK');



%--------- READING THE TRIAL PARAMETERS ----------------------------------------
        blockSTART     	   		=    ftell(fid);

	TrialTime(tnum,:)               =    (setstr(cprint('InitRead',[fid, 10,blockSTART,ParamBlockLength],'char')))';
	TrialDuration(tnum)             =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	OneStimDuration(tnum)           =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	TimeBetweenStim(tnum)           =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	Tilt(tnum)                      =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	RadialBoxSize(tnum)             =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	PerpenBoxSize(tnum)             =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	XStartPos(tnum)                 =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'short');
	YStartPos(tnum)                 =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'short');
	ExtentStimMotion(tnum)          =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	StimVelocity(tnum)              =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'short');
	ColorCode(tnum)                 =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'short');
	FgrRedInt(tnum)                 =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	FgrGreenInt(tnum)               =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	FgrBlueInt(tnum)                =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	BckgrRedInt(tnum)               =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	BckgrGreenInt(tnum)             =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	BckgrBlueInt(tnum)              =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	ElemRedInt(tnum)                =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	ElemGreenInt(tnum)              =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	ElemBlueInt(tnum)               =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
%               * * Applicable to Sinusoid & Gabor:  * *
	SpatialFreq(tnum)               =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	PhRed(tnum)                     =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');;
 	PhGreen(tnum)                   =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	PhBlue(tnum)                    =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');;
	StnDiv(tnum)                    =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	Contrast(tnum)                  =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	TempFreq(tnum)                  =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
%            * * Applicable to REGULAR: * *
	ElemLength(tnum)                =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	ElemWidth(tnum)                 =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	SpLengthDirec(tnum)             =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	SpWidthDirect(tnum)             =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
%            * * Additional timing values: * *
	StartEyeData(tnum)              =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	StartSpikeData(tnum)            =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	EndSpikeData(tnum)              =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	TimeCode(tnum)                  =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	StimTempType(tnum)              =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	StimSpatType(tnum)              =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
	EyeChoice(tnum)                 =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
%            * * Additional positioning info: * *
	SweepFract(tnum)                =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
        TrigTech(tnum)		        =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'ushort');
        SpikeTrig(tnum)		        =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
        ShapeTrig(tnum)		        =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
        ShapeHist(tnum)		        =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
        ShapeLen(tnum)		        =    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'short');
        ShapeTrigValue(tnum)		=    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'short');

%new addition 7/97
	FirstStimTime(tnum)	 	=    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'short');
	AngleFix(tnum)			=    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
        FixChangeTime(tnum)	 	=    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	SteadyFixTime(tnum)	 	=    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	FixNoChangeTime(tnum)	 	=    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	TotalFixDistance(tnum)	 	=    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');
	FixFraction(tnum)		=    cprint('InitRead',[fid, 1,blockSTART,ParamBlockLength],'float');

	   if cprint('NoSeparator',fid)
	    strerr = ['FORMAT ERROR on trialparam: file ', filename, ' skipped'];
	    disp(strerr);
	    fclose(fid);
	    return;
	   end;
% disp('TRIAL PARAMETERS  ...OK');


%--------- MEMORY ALLOCATION -----------------
              MaxSampNum =max(DataBlockLength(1)/2, DataBlockLength(2)/2); 
              HorizEyePos = zeros(MaxSampNum,1);
              VertEyePos = zeros(MaxSampNum,1);
              SpikeArrTime = zeros(DataBlockLength(3)/4,1);
%--------- READING THE HORIZONTAL EYE POSITION ----------------------------------------

	HorizEyePos             =    (fread(fid,DataBlockLength(1)/2,'short'))';

	   if cprint('NoSeparator',fid)
	    strerr = ['FORMAT ERROR on XEyePos: file ', filename, ' skipped'];
	    disp(strerr);
	    fclose(fid);
	    return;
           end;
               HorizEyePos = (HorizEyePos - EyetrackArbV0.*ones(size(HorizEyePos)))./(HorizEyePosGain*EyetrackArbDef);
               % disp('HORIZONTAL EYE POSITION  ...OK');

              %----------- READING THE VERTICAL EYE POSITION ---------------------------------------

	VertEyePos              =    (fread(fid,DataBlockLength(2)/2,'short'))';

	   if cprint('NoSeparator',fid)
	    strerr = ['FORMAT ERROR on YEyePos: file ', filename, ' skipped'];
	    disp(strerr);
	    fclose(fid);
	    return;

	   end;
	VertEyePos = (VertEyePos - EyetrackArbV0.*ones(size(VertEyePos)))./(VertEyePosGain*EyetrackArbDef);
 
 % disp('VERTICAL EYE POSITION ...OK');

% ------------ READING THE SPIKES DATA ------------------------------------------------

	SpikeArrTime            =    (fread(fid,DataBlockLength(3)/4,'long'))';
	   if cprint('NoSeparator',fid)
	    strerr = ['FORMAT ERROR on Spiketime: file ', filename, ' skipped'];
	    disp(strerr);
	    fclose(fid);
	    return;
  	   end;
 % disp('SPIKE ARRIVAL TIMES  ...OK');
% disp('OK');
	SpikeArrTime = SpikePer.*SpikeArrTime;

        if (ShapePer >0) & (DefValues(17)),

%------------------ READING OF THE SHAPE DATA

% ------------ READING THE SPIKE SHAPE TIMING DATA ------------------------------------------------

	RawShapeArrTime            =    (fread(fid,DataBlockLength(4)/4,'long'))';

	   if cprint('NoSeparator',fid)
	    strerr = ['FORMAT ERROR IN THE SPIKE SHAPE TIMING DATA: file ', filename, ' skipped'];
	    disp(strerr);
	    fclose(fid);
	    return;
	   end;
      
	ShapeArrTime = ShapePer.*RawShapeArrTime;
% disp('SHAPE ARRIVAL TIMES  ...OK');

%------Charley's !!!
if (TrialDuration(tnum) < max(SpikeArrTime)) | (TrialDuration(tnum) > 10000), 
   TrialDuration(tnum) = max(SpikeArrTime); 
end;

% ------------ READING THE SPIKE SHAPE VALUES DATA ------------------------------------------------


	ShapeAmp            =    (fread(fid,DataBlockLength(5)/2,'short'))';
	   if cprint('NoSeparator',fid)
	    strerr = ['FORMAT ERROR IN THE SPIKE SHAPE VALUES DATA: file ', filename, ' skipped'];
	    disp(strerr);
	    fclose(fid);
	    return;
	   end;

        % A/D --> mV
        lgn = length(FileDate);
        
        year = str2num(FileDate((lgn-1):lgn));
        
        if   (year ==95 ) | (year==96),				% diff scaling factor for 1995 and 1996			
             ShapeAmp = ShapeAmp/2000;
        else  
             ShapeAmp = 10*ShapeAmp/32768;				       
        end;

%disp('SHAPE AMPLITUDE ...OK');
%---------------- Shape Buffer:

	ShapeBufSize = length(ShapeAmp)/ShapeLen(tnum);
	ShapeBuf = zeros(ShapeBufSize,ShapeLen(tnum));
	for sh = 0:ShapeBufSize-1,
	  ShapeBuf(sh+1,:) = ShapeAmp(sh*ShapeLen(tnum)+1:(sh+1)*ShapeLen(tnum));
%	  ShapeBuf(sh+1,:) = ShapeAmp(sh*ShapeLen+1:(sh+1)*ShapeLen(tnum));
	end;


%------------------ END READING OF THE SHAPE DATA

%----------------- END READING TRIAL ---------------------------------------------
     
       end;

% CONSIDER THE TIME AXIS... ---------------------------------------------------------
	EyeTimeAxis = StartEyeData(tnum) + EyePer.*[0:length(HorizEyePos)-1];
	if DataBlockLength(3),
	  % STORING SPIKES DATA
	  nrow = size(SPIKES,1);                %=TrialsNum of the given file
	  ncol = size(SPIKES,2);
	  SpikesNum = DataBlockLength(3)/4;
	  if SpikesNum > ncol-3,
	     tmp = zeros(TrialsNum,SpikesNum +3);
	     for i=1:nrow,
	       tmp(i,1:ncol) = SPIKES(i,:);
	     end;
	     SPIKES = [];
	     SPIKES = tmp;
	  else
	     SPIKES = [SPIKES; zeros(1,ncol)];

	  end;
	  SPIKES(tnum,1) = DataBlockLength(3)/4;
	  SPIKES(tnum,2) = StartSpikeData(tnum);
	  SPIKES(tnum,3) = EndSpikeData(tnum);
	   bins=(StartSpikeData(tnum):DefValues(1):EndSpikeData(tnum));
	  SPIKES(tnum,4:SpikesNum + 3) = SpikeArrTime;
%---------- HISTOGRAM COMPUTING -------------------------
	if DefValues(1)
           [N,SpikeHist]=hist(SpikeArrTime,bins);
           [xx,yy] = bar(SpikeHist,N);

	else
	   xx = zeros(1,3*SpikesNum);
	   xx(1:3:(3*SpikesNum-2)) = SPIKES(tnum,4:(SpikesNum + 3));
	   xx(2:3:(3*SpikesNum-1)) = SPIKES(tnum,4:(SpikesNum + 3));
	   xx(3:3:(3*SpikesNum))   = SPIKES(tnum,4:(SpikesNum + 3));
	   yy = zeros(1,3*SpikesNum);
	   yy(2:3:(3*SpikesNum-1)) = ones(1,SpikesNum); 
	end;    
	       end;
     

% STORING STIMULUS DATA;

% IF TIME BETWEEN STIMULUS = 0....
	if TimeBetweenStim(tnum) == 0,
	   TimeBetweenStim(tnum) = OneStimDuration(tnum);
	end;
	% IF FLAG 'NO MOTION' WAS OBSERVED;
	if StimTempType(tnum)==0,             % no motion
	   StimArrTime=0;
	   StimNum = 1;
	   OneStimDuration(tnum)=0;
	   TimeBetweenStim(tnum)=TrialDuration(tnum);
	end;
	% IF STIMULUS DURATION = 0;
	if (OneStimDuration(tnum)+TimeBetweenStim(tnum)==0)
	   StimArrTime=0;
	   StimNum = 1;
	   OneStimDuration(tnum)=0;
	   TimeBetweenStim(tnum)=TrialDuration(tnum);
                end;
	StimArrTime = [0:OneStimDuration(tnum)+TimeBetweenStim(tnum):TrialDuration(tnum)-1];
	StimNum = length(StimArrTime);
	
	ncol = size(STIMULUS,2);
	nrow = size(STIMULUS,1);                %=TrialsNum of the given file
	
% put new stimuli vector to the global STIMULUS array    
        nncol = max((StimNum +4), ncol);
        tmp = zeros(tnum,nncol);
        
        for i=1:nrow,
          tmp(i,1:ncol) = STIMULUS(i,:);
        end;
        STIMULUS = [];
        STIMULUS = tmp;



	STIMULUS(tnum,1) = StimNum;
	STIMULUS(tnum,2) = TrialDuration(tnum);
	STIMULUS(tnum,3) = OneStimDuration(tnum);
	STIMULUS(tnum,4) = TimeBetweenStim(tnum);
	STIMULUS(tnum,5:(StimNum + 4)) = StimArrTime;
	Front = 0;
	SpStim = round(OneStimDuration(tnum)/EyePer); 
	SpPause = round(TimeBetweenStim(tnum)/EyePer);
	SpStimAll = ceil(TrialDuration(tnum)/EyePer);
	if(SpStimAll <= 1),
	   axis off;
	   text(.3, .5, 'File does not constist data');
	   return;
	end;
	
         
        ax = axes('Position',rect(graphposition,:), 'XLim', [0 STIMULUS(tnum,2)]);
        line([0 STIMULUS(tnum,2)],[DefValues(10)/5 DefValues(10)/5],...
        'Color','k','LineStyle',':'); 
        line([0 STIMULUS(tnum,2)],[DefValues(7)/5 DefValues(7)/5],...
        'Color','k','LineStyle',':'); 

	% PLOTTING THE EYE MOVEMENT

	line(EyeTimeAxis,HorizEyePos,'Color','g');
	line(EyeTimeAxis,VertEyePos,'Color','m','LineWidth',1);

%---------------- SPIKES HISTOGRAM DRAWING --------------------------------------
	if SpikesNum,
	 his = []; 
                 SpikeAmp = (DefValues(10) - DefValues(7)) / (5*max(yy));
	 h = line(xx,SpikeAmp*yy+DefValues(7),'Color','r');
	end;

	%---------------- STIMULI DRAWING ----------------------------------------------
 if (OneStimDuration > 100)		% avoid multiple drawing while flash
	for i=1:length(StimArrTime),
	   Slope = Front+SpStim;
	   if Slope > SpStimAll;
	      Slope = SpStimAll;
	   end;

	   x = [StimArrTime(i) (OneStimDuration(tnum)+StimArrTime(i)-1)];
	   y = [ones(size(x))+DefValues(7)];
	   line(x,y,'Color','g','LineWidth',1.5);

	   x = [(StimArrTime(i)+OneStimDuration(tnum)) (StimArrTime(i)+OneStimDuration(tnum)+TimeBetweenStim(tnum)-1)];
	   y = [ones(size(x))+DefValues(7)];
	   line(x,y,'Color','b','LineWidth',3.5);
  	   Front = Slope+SpPause;
        end;
      end;
      set(text,'String',['Trial #',num2str(tnum)],'units','normal','Position', [.7 .8]);

        if (ShapePer >0) & (DefValues(17)),
	  drawshapenum(graphposition) = min(DefValues(18),size(ShapeBuf,1));
	  if (drawshapenum(graphposition))
             drawshapestep = max(fix(size(ShapeBuf,1)/drawshapenum(graphposition)),1);
             drawshapeind =  [1:drawshapestep:size(ShapeBuf,1)];

             r(graphposition)=axes('Position',rectshape(graphposition,:));

            plot(ShapeBuf(drawshapeind,:)','g');
            txt = text;
            set(txt,'String',['Trial #',num2str(tnum)],'units','normal',...
               'FontSize',8); 

            set(r(graphposition),'XLim',[1 size(ShapeBuf,2)],'Ylimmode','auto','FontSize',8,...
                'title',txt);
             MinShape(graphposition) = min(min(ShapeBuf)); 
            MaxShape(graphposition) = max(max(ShapeBuf));
          end;      
        end;

%-------------------------------------------------------
        graphposition=graphposition+1;
%------------------------------------------------------

%text output on the screen:
       if (graphposition > DefValues(4)) | (tnum==TrialsNum),    %it is a good time to change the screen

   if length(DataBlockLength)>3,
        for i = 1: graphposition-1,

         if (~DefValues(21) & DefValues(17) & drawshapenum(i) ),		%shape autscale = off
           set(r(i),'Ylim',[min(MinShape) max(MaxShape)]);
         end;

       end;
   end;

         axes('Position',[0 0 1 1],'Visible','off','DefaultTextUnits','Normal',...
         'DefaultTextFontName','Times');

         set(text,'Position',[.005 .37],'Color','r','string','File name:','FontWeight','demi','FontAngle','italic'); 
         set(text,'Position',[.1 .37],'Color','k','string',deblank(filename),'FontWeight','demi'); 
     
         set(text,'Position',[.35 .37],'Color','r','string','File Date:','FontWeight','demi','FontAngle','italic'); 
         set(text,'Position',[.42 .37],'Color','k','string',deblank(FileDate),'FontWeight','demi'); 
  
%         set(text,'Position',[.005 .38],'Color','r','string','Run mode:'); 
%         set(text,'Position',[.16 .38],'Color','k','string',deblank(RunModName)); 

%         set(text,'Position',[.005 .36],'Color','r','string','Video frame T, ms:'); 
%         set(text,'Position',[.16 .36],'Color','k','string',num2str(VideoFramePeriod)); 

         set(text,'Position',[.5 .37],'Color','r','string','View distance,cm:','FontWeight','demi','FontAngle','italic'); 
         set(text,'Position',[.6 .37],'Color','k','string',num2str(ViewDistance),'FontWeight','demi'); 

%         set(text,'Position',[.005 .32],'Color','r','string','First sample time:'); 
%         set(text,'Position',[.16 .32],'Color','k','string',num2str(TimeFirstSample)); 

%         set(text,'Position',[.005 .30],'Color','r','string','Samp. per frame:'); 
%         set(text,'Position',[.16 .30],'Color','k','string',num2str(NumSamp2Frame)); 

%         set(text,'Position',[.005 .28],'Color','r','string','Vis field loc:'); 
%         set(text,'Position',[.16 .28],'Color','k','string',...
%	[num2str(HorizVisualFieldLoc),',',num2str(VertVisualFieldLoc)]); 
          

%         set(text,'Position',[.005 .26],'Color','r','string','LED position:'); 
%         set(text,'Position',[.16 .26],'Color','k','string',...
%	[num2str(HorizPosLED),',',num2str(VertPosLED)]); 

%         set(text,'Position',[.005 .24],'Color','r','string','Eye position gain:'); 
%         set(text,'Position',[.16 .24],'Color','k','string',...
%	[num2str(HorizEyePosGain),',',num2str(VertEyePosGain)]); 

%         set(text,'Position',[.005 .22],'Color','r','string','Eye track arb. def.:'); 
%         set(text,'Position',[.16 .22],'Color','k','string',num2str(EyetrackArbDef)); 

%         set(text,'Position',[.005 .20],'Color','r','string','Eye track arb. V0.:'); 
%         set(text,'Position',[.16 .20],'Color','k','string',num2str(EyetrackArbV0)); 

%         set(text,'Position',[.005 .18],'Color','r','string','Edge, left, right:'); 
%         set(text,'Position',[.16 .18],'Color','k','string',...
%	 [num2str(LeftEdge),',',num2str(RightEdge)]); 

%         set(text,'Position',[.005 .16],'Color','r','string','Edge, bottom, top:'); 
%         set(text,'Position',[.16 .16],'Color','k','string',...
%         [num2str(BottomEdge),',',num2str(TopEdge)]); 

         set(text,'Position',[.63 .37],'Color','r','string','X,Y Gain:','FontWeight','demi','FontAngle','italic'); 
         set(text,'Position',[.69 .37],'Color','k', 'FontWeight','demi', 'string',...
	[num2str(HorizEyePosGain),',  ',num2str(VertEyePosGain)]); 

         set(text,'Position',[.75 .37],'Color','r','string','Stab flag:','FontWeight','demi','FontAngle','italic'); 
         str = cprint('translate','StabFlag',StabFlag);
         set(text,'Position',[.8 .37],'Color','k','string',str,'FontWeight','demi'); 


%         set(text,'Position',[.005 .12],'Color','r','string','Comp flag:'); 
%         set(text,'Position',[.16 .12],'Color','k','string',num2str(CompFlag)); 

%         set(text,'Position',[.005 .1],'Color','r','string','Eye period, ms:'); 
%         set(text,'Position',[.16 .1],'Color','k','string',num2str(EyePer)); 

%         set(text,'Position',[.005 .08],'Color','r','string','Spike period, ms:'); 
%         set(text,'Position',[.16 .08],'Color','k','string',num2str(SpikePer)); 

%         set(text,'Position',[.005 .06],'Color','r','string','Time:'); 
%         set(text,'Position',[.16 .06],'Color','k','string',deblank(DateTime)); 
  



         if (CommLength),
           set(text,'Position',[.005 .35],'Color','r','string','Comments:'); 
           set(text,'Position',[.16 .35],'Color','k','string',deblank(Comments)); 
         end;
%--------------------------
    ref_tnum = tnum-graphposition+2;
    set(text,'Position',[.005 .33],'Color','r','string',['Trial #', num2str(ref_tnum), ', Time:']); 
    set(text,'Position',[.16 .33],'Color','k','string',deblank(TrialTime(ref_tnum,:))); 
       
    set(text,'Position',[.005 .315],'Color','r','string','Trial Duration:'); 
    set(text,'Position',[.16 .315],'Color','k','string',num2str(TrialDuration(ref_tnum))); 

    set(text,'Position',[.005 .3],'Color','r','string','One Stimulus Duration:'); 
    set(text,'Position',[.16 .3],'Color','k','string',num2str(OneStimDuration(ref_tnum))); 

    set(text,'Position',[.005 .285],'Color','r','string','Time between stimuli:'); 
    set(text,'Position',[.16 .285],'Color','k','string',num2str(TimeBetweenStim(ref_tnum))); 

    set(text,'Position',[.005 .27],'Color','r','string','Tilt:'); 
    set(text,'Position',[.16 .27],'Color','k','string',num2str(Tilt(ref_tnum))); 

    set(text,'Position',[.005 .255],'Color','r','string','Radial box size:'); 
    set(text,'Position',[.16 .255],'Color','k','string',num2str(RadialBoxSize(ref_tnum))); 

    set(text,'Position',[.005 .24],'Color','r','string','Perp. box size'); 
    set(text,'Position',[.16 .24],'Color','k','string',num2str(PerpenBoxSize(ref_tnum))); 

    set(text,'Position',[.005 .225],'Color','r','string','Start position (X,Y):'); 
    set(text,'Position',[.16 .225],'Color','k','string',...
     	[num2str(XStartPos(ref_tnum)),', ',num2str(YStartPos(ref_tnum))]); 

    set(text,'Position',[.005 .21],'Color','r','string','Extent stim motion:'); 
    set(text,'Position',[.16 .21],'Color','k','string', num2str(ExtentStimMotion(ref_tnum))); 

    set(text,'Position',[.005 .195],'Color','r','string','Stim. velocity :'); 
    set(text,'Position',[.16 .195],'Color','k','string',num2str(StimVelocity(ref_tnum))); 

%    set(text,'Position',[.005 .18],'Color','r','string','ColorCode:'); 
%    set(text,'Position',[.16 .18],'Color','k','string',num2str(ColorCode(ref_tnum))); 

    string=sprintf('%4.2f ',[FgrRedInt(ref_tnum) FgrGreenInt(ref_tnum) FgrBlueInt(ref_tnum)]);
    set(text,'Position',[.005 .18],'Color','r','string','Foreground intensity:'); 
    set(text,'Position',[.16 .18],'Color','k','string',string);
    
    string=sprintf('%4.2f ',[BckgrRedInt(ref_tnum) BckgrGreenInt(ref_tnum) BckgrBlueInt(ref_tnum)]);
    set(text,'Position',[.005 .165],'Color','r','string','Background  intensity:'); 
    set(text,'Position',[.16 .165],'Color','k','string',string);

    set(text,'Position',[.005 .15],'Color','r','string','Eye choice:');
    strn = cprint('translate','EyeChoice',EyeChoice(ref_tnum));
    set(text,'Position',[.16 .15],'Color','k','string',strn); 

    set(text,'Position',[.005 .135],'Color','r','string','Stim. spatial type:'); 
    strn = cprint('translate','StimSpatType',StimSpatType(ref_tnum));
    set(text,'Position',[.16 .135],'Color','k','string',strn); 
   
    set(text,'Position',[.005   .12],'Color','r','string','Stim. temporal type:'); 
    strn = cprint('translate','StimTempType',StimTempType(ref_tnum));
    set(text,'Position',[.16 .12],'Color','k','string',strn); 
	

    if StimSpatType(ref_tnum)==4,		% regular texture 
      string=sprintf('%4.2f ',[ElemRedInt(ref_tnum) ElemGreenInt(ref_tnum) ElemBlueInt(ref_tnum)]);
      set(text,'Position',[.005 .105],'Color','r','string','Element intensity:'); 
      set(text,'Position',[.16 .105],'Color','k','string',string);

      set(text,'Position',[.005 .09],'Color','r','string','Elem length:'); 
      set(text,'Position',[.16 .09],'Color','k','string',num2str(ElemLength(ref_tnum))); 

      set(text,'Position',[.005 .075],'Color','r','string','Elem width:'); 
      set(text,'Position',[.16 .075],'Color','k','string',num2str(ElemWidth(ref_tnum))); 

      set(text,'Position',[.005 .06],'Color','r','string','Sp. length direc.:'); 
      set(text,'Position',[.16 .06],'Color','k','string',num2str(SpLengthDirec(ref_tnum))); 

      set(text,'Position',[.005 .045],'Color','r','string','Sp. width direc.:'); 
      set(text,'Position',[.16 .045],'Color','k','string',num2str(SpWidthDirect(ref_tnum))); 


    elseif (StimSpatType(ref_tnum)== 1 | StimSpatType(ref_tnum)== 2 | StimSpatType(ref_tnum)== 6),	%sinus or gabor
       
      set(text,'Position',[.005 .105],'Color','r','string','Spatial frequency :'); 
      set(text,'Position',[.16 .105],'Color','k','string',num2str(SpatialFreq(ref_tnum))); 

      set(text,'Position',[.005 .09],'Color','r','string','Temporal frequency:'); 
      set(text,'Position',[.16 .09],'Color','k','string',num2str(TempFreq(ref_tnum))); 

      set(text,'Position',[.005 .075],'Color','r','string','Contrast:'); 
      set(text,'Position',[.16 .075],'Color','k','string',num2str(Contrast(ref_tnum))); 

      set(text,'Position',[.005 .06],'Color','r','string','Standard diviation:'); 
      set(text,'Position',[.16 .06],'Color','k','string',num2str(StnDiv(ref_tnum))); 

%      string=sprintf('%4.2f ',[PhRed(ref_tnum) PhGreen(ref_tnum) PhBlue(ref_tnum)]);
%      set(text,'Position',[.005 .045],'Color','r','string','Ph:'); 
%      set(text,'Position',[.16 .045],'Color','k','string',string);

    elseif StimSpatType(ref_tnum)== 3,		%gaussian
      % nothing
    elseif StimSpatType(ref_tnum)== 5,		%random
    end;
 
  

%    set(text,'Position',[.005 .105],'Color','r','string','Time code:'); 
%    set(text,'Position',[.16 .105],'Color','k','string',num2str(TimeCode(ref_tnum))); 

  

%    set(text,'Position',[.005 .09],'Color','r','string','Sweep fraction:'); 
%    set(text,'Position',[.16 .09],'Color','k','string',num2str(SweepFract(ref_tnum))); 
    
    pos=[.27 0.33];
    set(text,'Position',pos,'Color','r','string','Changes:','FontWeight','demi'); 

    for i=ref_tnum+1:tnum,
      ChangesFlag = 0;
      str=[];

      if TrialDuration(i)~=TrialDuration(i-1) & ~isnan(TrialDuration),
         ChangesFlag = 1;
         str = str2mat(str,['Trial Duration = ',num2str(TrialDuration(i))]);
      end; 
      
      if OneStimDuration(i)~=OneStimDuration(i-1) & ~isnan(OneStimDuration),
         ChangesFlag = 1;
         str = str2mat(str,['One Stimulus Duration = ',num2str(OneStimDuration(i))]);
      end;
      
      if TimeBetweenStim(i)~=TimeBetweenStim(i-1) & ~isnan(TimeBetweenStim),
         ChangesFlag = 1;
         str = str2mat(str,['Time between stimuli = ',num2str(TimeBetweenStim(i))]);
      end; 

      if Tilt(i)~=Tilt(i-1) & ~isnan(Tilt),
         ChangesFlag = 1;
         str = str2mat(str,['Tilt = ',num2str(Tilt(i))]);
      end;
      
      if RadialBoxSize(i)~=RadialBoxSize(i-1) & ~isnan(RadialBoxSize),
         ChangesFlag = 1;
         str = str2mat(str,['Radial box size = ',num2str(RadialBoxSize(i))]);
      end; 
      
      if PerpenBoxSize(i)~=PerpenBoxSize(i-1) & ~isnan(PerpenBoxSize),
         ChangesFlag = 1;
         str = str2mat(str,['Perp. box size = ',num2str(PerpenBoxSize(i))]);
      end; 
      
      if XStartPos(i)~=XStartPos(i-1) & ~isnan(XStartPos),
         ChangesFlag = 1;
         str = str2mat(str,['X Start position = ',num2str(XStartPos(i))]);
      end; 
      
      if YStartPos(i)~=YStartPos(i-1) & ~isnan(YStartPos),
         ChangesFlag = 1;
         str = str2mat(str,['Y Start position = ',num2str(YStartPos(i))]);
      end; 
      
       if ExtentStimMotion(i)~=ExtentStimMotion(i-1) & ~isnan(ExtentStimMotion),
         ChangesFlag = 1;
         str = str2mat(str,['Extent stim. motion = ',num2str(ExtentStimMotion(i))]);
      end; 
      
      if StimVelocity(i)~=StimVelocity(i-1) & ~isnan(StimVelocity),
         ChangesFlag = 1;
         str = str2mat(str,['Stim. velocity = ',num2str(StimVelocity(i))]);
      end; 
      
      if FgrRedInt(i)~=FgrRedInt(i-1) & ~isnan(FgrRedInt),
         ChangesFlag = 1;
         str = str2mat(str,['Foregr. Red Int = ',num2str(FgrRedInt(i))]);
      end; 

      if FgrGreenInt(i)~=FgrGreenInt(i-1) & ~isnan(FgrGreenInt),
         ChangesFlag = 1;
         str = str2mat(str,['Foregr. Green Int = ',num2str(FgrGreenInt(i))]);
      end; 

      if FgrBlueInt(i)~=FgrBlueInt(i-1) & ~isnan(FgrBlueInt),
         ChangesFlag = 1;
         str = str2mat(str,['Foregr. Blue Int = ',num2str(FgrBlueInt(i))]);
      end; 

      if BckgrRedInt(i)~=BckgrRedInt(i-1) & ~isnan(BckgrRedInt),
         ChangesFlag = 1;
         str = str2mat(str,['Bckgr. Red Int = ',num2str(BckgrRedInt(i))]);
      end; 

      if BckgrGreenInt(i)~=BckgrGreenInt(i-1) & ~isnan(BckgrGreenInt),
         ChangesFlag = 1;
         str = str2mat(str,['Bckgr. Green Int = ',num2str(BckgrGreenInt(i))]);
      end; 
%%%%%%%%%%%
      if BckgrBlueInt(i)~=BckgrBlueInt(i-1) & ~isnan(BckgrBlueInt),
         ChangesFlag = 1;
         str = str2mat(str,['Bckgr. Blue Int = ',num2str(BckgrBlueInt(i))]);
      end; 
      
      if ElemRedInt(i)~=ElemRedInt(i-1) & ~isnan(ElemRedInt),
         ChangesFlag = 1;
         str = str2mat(str,['Elem. Red Int = ',num2str(ElemRedInt(i))]);
      end; 

      if ElemGreenInt(i)~=ElemGreenInt(i-1) & ~isnan(ElemGreenInt),
         ChangesFlag = 1;
         str = str2mat(str,['Elem. Green Int = ',num2str(ElemGreenInt(i))]);
      end; 

      if ElemBlueInt(i)~=ElemBlueInt(i-1) & ~isnan(ElemBlueInt),
         ChangesFlag = 1;
         str = str2mat(str,['Elem. Blue Int = ',num2str(ElemBlueInt(i))]);
      end; 
 
      if ElemLength(i)~=ElemLength(i-1) & ~isnan(ElemLength),
         ChangesFlag = 1;
         str = str2mat(str,['Elem length = ',num2str(ElemLength(i))]);
      end; 
      
      if ElemWidth(i)~=ElemWidth(i-1) & ~isnan(ElemWidth),
         ChangesFlag = 1;
         str = str2mat(str,['Elem width = ',num2str(ElemWidth(i))]);
      end; 
      
      if EyeChoice(i)~=EyeChoice(i-1) & ~isnan(EyeChoice),
         ChangesFlag = 1;
         strn = cprint('translate','EyeChoice',EyeChoice(i));
         str = str2mat(str,['Eye choice = ',strn]);
      end; 

      if StimSpatType(i)~=StimSpatType(i-1) & ~isnan(StimSpatType),
         ChangesFlag = 1;
         strn = cprint('translate','StimSpatType',StimSpatType(i));
         str = str2mat(str,['Stim. spatial type = ',strn]);
      end; 

      if SpatialFreq(i)~=SpatialFreq(i-1) & ~isnan(SpatialFreq),
         ChangesFlag = 1;
         str = str2mat(str,['Spatial freq. = ',num2str(SpatialFreq(i))]);
      end; 

      if TempFreq(i)~=TempFreq(i-1) & ~isnan(TempFreq),
         ChangesFlag = 1;
         str = str2mat(str,['Temporal freq. = ',num2str(TempFreq(i))]);
      end; 

      if StnDiv(i)~=StnDiv(i-1) & ~isnan(StnDiv),
         ChangesFlag = 1;
         str = str2mat(str,['STD = ',num2str(StnDiv(i))]);
      end; 

      if Contrast(i)~= Contrast(i-1) & ~isnan(Contrast),
         ChangesFlag = 1;
         str = str2mat(str,['Contrast = ',num2str(Contrast(i))]);
      end; 

      if PhRed(i)~= PhRed(i-1) & ~isnan(PhRed),
         ChangesFlag = 1;
         str = str2mat(str,['PhRed = ',num2str(PhRed(i))]);
      end; 

 
      if PhGreen(i)~= PhGreen(i-1) & ~isnan(PhGreen),
         ChangesFlag = 1;
         str = str2mat(str,['PhGreen = ',num2str(PhGreen(i))]);
      end; 

     if PhBlue(i)~= PhBlue(i-1) & ~isnan(PhBlue),
         ChangesFlag = 1;
         str = str2mat(str,['PhBlue = ',num2str(PhBlue(i))]);
      end; 
      
      if SweepFract(i)~=SweepFract(i-1) & ~isnan(SweepFract),
         ChangesFlag = 1;
         str = str2mat(str,['Sweep fraction = ',num2str(SweepFract(i))]);
      end; 
      
     if TrigTech(i)~= TrigTech(i-1) & ~isnan(TrigTech),
         ChangesFlag = 1;
         str = str2mat(str,['Triggering method = ',num2str(TrigTech(i))]);
      end; 

     if SpikeTrig(i)~= SpikeTrig(i-1) & ~isnan(SpikeTrig),
         ChangesFlag = 1;
         str = str2mat(str,['Spike trig. volt = ',num2str(SpikeTrig(i))]);
      end; 

     if ShapeTrig(i)~= ShapeTrig(i-1) & ~isnan(ShapeTrig),
         ChangesFlag = 1;
         str = str2mat(str,['Shape trig. volt = ',num2str(ShapeTrig(i))]);
      end; 

     if ShapeHist(i)~= ShapeHist(i-1) & ~isnan(ShapeHist),
         ChangesFlag = 1;
         str = str2mat(str,['Shape hysteresis = ',num2str(ShapeHist(i))]);
      end; 

     if ShapeLen(i)~= ShapeLen(i-1) & ~isnan(ShapeLen),
         ChangesFlag = 1;
         str = str2mat(str,['Shape length = ',num2str(ShapeLen(i))]);
      end; 

     if ShapeTrigValue(i)~= ShapeTrigValue(i-1) & ~isnan(ShapeTrigValue),
         ChangesFlag = 1;
         str = str2mat(str,['Shape trig. value = ',num2str(ShapeTrigValue(i))]);
      end; 

 %new addition 7/97
     if FirstStimTime(i)~= FirstStimTime(i-1) & ~isnan(FirstStimTime),
         ChangesFlag = 1;
         str = str2mat(str,['First stim. time = ',num2str(FirstStimTime(i))]);
      end; 

     if AngleFix(i)~= AngleFix(i-1) & ~isnan(AngleFix),
         ChangesFlag = 1;
         str = str2mat(str,['Angle between targets = ',num2str(AngleFix(i))]);
      end; 


     if FixChangeTime(i)~= FixChangeTime(i-1) & ~isnan(FixChangeTime),
         ChangesFlag = 1;
         str = str2mat(str,['Time of 1-st fix. change = ',num2str(FixChangeTime(i))]);
      end; 

     if SteadyFixTime(i)~= SteadyFixTime(i-1) & ~isnan(SteadyFixTime),
         ChangesFlag = 1;
         str = str2mat(str,['Steady fix. time = ',num2str(SteadyFixTime(i))]);
      end; 

     if FixNoChangeTime(i)~= FixNoChangeTime(i-1) & ~isnan(FixNoChangeTime),
         ChangesFlag = 1;
         str = str2mat(str,['Fix. time of no change = ',num2str(FixNoChangeTime(i))]);
      end; 

     if TotalFixDistance(i)~= TotalFixDistance(i-1) & ~isnan(TotalFixDistance),
         ChangesFlag = 1;
         str = str2mat(str,['Total distance = ',num2str(TotalFixDistance(i))]);
      end; 

     if FixFraction(i)~= FixFraction(i-1) & ~isnan(FixFraction),
         ChangesFlag = 1;
         str = str2mat(str,['Fix. fraction = ',num2str(FixFraction(i))]);
      end; 



      
      if ChangesFlag,
         str(1,:) = [];			% first empty line should be erased
         str = str2mat(['Trial # ',num2str(i)], str);
         rows=size(str,1);
         for j=1:rows,
           set(text,'Position',[pos(1) pos(2)-j*0.02],'Color','b','string',deblank(str(j,:))); 
         end;
         pos(1) = pos(1)+.15;
     end;  
   end; 
    
       
   set(Fig2,'Visible',vis);

     if(DefValues(13)),  pause(0.5); end;
     
     
           orient landscape;
           
           if DefValues(16)==0,
              print;
           else,
              if DefValues(16)==1,
                 ext = 'ps';
                 device = '-dps';
              elseif DefValues(16)==2,   
                 ext = 'hp';
                 device = '-dljet2p';
              elseif DefValues(16)==3,   
                 ext = 'hp';
                 device = '-dljet3';
              end;                                                                 
              [a,b]=min(abs(filename - '.'));
              if a==0, outname = [filename(1:b),ext,num2str(frame)];
              else
                      outname = [filename,ext,num2str(frame)];
              end;

              nnn=1;
              while (exist(outname)==2)
                 outname = [filename(1:b), ext,num2str(frame+nnn)];
		 nnn= nnn+1;
              end;
              com=['print ',device,' ', outname];

              eval(com);
            end;
            frame = frame+1;           
            
% All this part was written to avoid matlab's print bug:
      if  (~DefValues(13)),
           delete(CPRINT_DAT(2)), 
           CPRINT_DAT(2) = []; 
                       Fig2 = figure('Units','normal', 'Position',[0.005 0.04 .9 .8],...
		     'Backingstore','off','color','w','Name', 'Trials Graph','DefaultAxesXcolor','k',...
		     'DefaultAxesFontSize',9,'DefaultAxesDrawMode','fast','visible',vis,...
		     'DefaultAxesYColor','k', 'DefaultAxesYLim',[DefValues(7) DefValues(10)]);
                       CPRINT_DAT(2) = Fig2;

      else
          clf;
      end; 
%-----------------------------------------------

           drawnow discard;    
          graphposition = 1;
        end;
    end;     
%------------
   
strOK = ['File ',filename, ' was printed succesfully'];
disp(strOK);
fclose(fid);
%---------------------------------------------------------------------------------------------------------------------------------------------------------------     

   elseif(strcmp(action,'update'))
	  if (in1),

	      h=get(gcf,'CurrentObject');
    
	      DefValues = get(0,'UserData');
	      newdata = round(str2num(deblank(get(h,'String'))));
	      a = newdata >= DefValues(in1+1);
	      b = newdata <= DefValues(in1+2);
	      if (a&b),
		   DefValues(in1) = newdata;
		   set(0,'UserData',DefValues);       
	      else,
		   set(h,'String',num2str(DefValues(in1)));
	      end;
                  end;
%---------------------------------------------------------------------------------------------------------------------------------------------------------------     
   elseif(strcmp(action,'exit')),
      delete(CPRINT_DAT(1));
%      clear variables;

%------------------------------------------------------------------------

elseif(strcmp(action,'translate'))

  in2 = in2+1;
  
  if strcmp(in1,'StimTempType'),
     strings = str2mat('No motion','Alternating','Flashing','Repeating');

  elseif strcmp(in1,'StimSpatType'), 
     strings  = str2mat('Solid tilted rectangular','Sinus','Gabor','6-th deriv of Gaussian',...
    			'Regular texture','Random','WIN_SINU','CNTR_SIN','MAX_PAT_TYPE');   

  elseif strcmp(in1,'EyeChoice'), 
     strings  = str2mat('No eyes','Left','Right','Both');

  elseif strcmp(in1,'StabFlag'),  
     strings  = str2mat('No stab.','Every frame','Even frames');

 elseif strcmp(in1,'CompFlag'),  
     strings  = str2mat('Control PC','Anal PC');


  elseif strcmp(in1,'FixationType'),
     strings  = str2mat('1 static LED','Multiple LEDs','Oscilloscope',...
                      'Stimulus target');
     
  end;
  if in2 > size(strings,1)
     out1 = 'unknown';
  else   
     out1 = deblank(strings(in2,:)); 
  end;
%-------------------------------------------------------------------------------

elseif(strcmp(action,'clear')),
  cla;
  axis('off');
  set(CPRINT_DAT(1),'UserData',[]);


elseif(strcmp(action,'NoSeparator')),

	Separator = (setstr(fread(in1, 4,'uchar')))';
	if Separator  == 'wwww',
            out1 = 0;
        else
            out1 = 1;
        end;

elseif(strcmp(action,'InitRead')),
          fileHandler = in1(1);
          unitNum     = in1(2);
          blockStart  = in1(3);
          blockSize   = in1(4);
 
          unitFormat  = in2;

          curPos = ftell(fileHandler);		% find current position
          if (curPos - blockStart) < blockSize     
            out1 = fread(fileHandler,unitNum,unitFormat);
          else
            out1 = NaN;
          end;

%-------------------------------------------------------------------------------

elseif(strcmp(action,'compare')),
      NewVal = in1(i);


%-------------------------------------------------------------------------------

 end;		%else of actions
   
