function status = find_stab_flag_one_file(file_name)
[fid, message] = fopen(file_name,'rb');
if(fid<0), 
        status = message;
        return;
end;


StartPosition = ftell(fid);


% ---------- READING THE FILE HEADER BLOCK -----------------------
% Common for all actions

blockSTART		=    ftell(fid);
fseek(fid,2+4, -1);
FileHeaderLength        =    fread(fid, 1,'ushort');
fseek(fid,blockSTART, -1);

Ver                     =    fread(fid, 1,'ushort');
FileLength              =    fread(fid, 1,'long');
FileHeaderLength        =    fread(fid, 1,'ushort');

GlobSpecBlockNum        =    fread(fid, 1,'ushort');
TrialsNum               =    fread(fid, 1,'ushort');
CommLength              =    fread(fid, 1,'ushort');
GlobSpecBlockLength     =    fread(fid,GlobSpecBlockNum, 'ushort');
TrialBegin              =    fread(fid,TrialsNum,'long');

if unitret('NoSeparator',fid)
        status= ['FORMAT ERROR on FILEHEADER: file ', filename, ' skipped'];
        fclose(fid);
        return;
end;

% ---------- READING THE FILE SPECIFICATION  BLOCK -----------------------
blockSTART     	   =    ftell(fid);

FileName                =    (setstr(fread(fid, 14,'char')))';
FileDate                =    (setstr(fread(fid, 10,'char')))';
RunModName              =    (setstr(fread(fid, 10,'char')))';
VideoFramePeriod        =    fread(fid,1,'float');
ViewDistance            =    fread(fid,1,'float');
TimeFirstSample         =    fread(fid,1,'float');
NumSamp2Frame           =    fread(fid,1,'ushort');
HorizVisualFieldLoc     =    fread(fid,1,'float');
VertVisualFieldLoc      =    fread(fid,1,'float');
HorizPosLED             =    fread(fid,1,'float');
VertPosLED              =    fread(fid,1,'float');
HorizEyePosGain         =    fread(fid,1,'float');
VertEyePosGain          =    fread(fid,1,'float');
EyetrackArbDef          =    fread(fid,1,'float');
EyetrackArbV0           =    fread(fid,1,'ushort');
Empty                   =    fread(fid,1,'ushort');
LeftEdge                =    fread(fid,1,'ushort');
BottomEdge              =    fread(fid,1,'ushort');
RightEdge               =    fread(fid,1,'ushort');
TopEdge                 =    fread(fid,1,'ushort');
StabFlag                =    fread(fid,1,'ushort');
Empty                   =    fread(fid,1,'ushort');     % temporal type: flag
Empty                   =    fread(fid,1,'ushort');     % spatial type: flag
CompFlag                =    fread(fid,1,'ushort');
DateTime                =    (setstr(fread(fid, 18,'uchar')))';
EyePer                  =    fread(fid,1,'float');
SpikePer                =    fread(fid,1,'float');
ShapePer                =    unifread([fid, 1,blockSTART,GlobSpecBlockLength],'float');
FixationType		=    unifread([fid, 1,blockSTART,GlobSpecBlockLength],'ushort');

fclose(fid);

if StabFlag == 0,
        status = '0';
else
        status = '1';    
end
