function [numsets,totalsweeps, totalspikes, data] = unispikedatf(fname);
% unispikedatf	- reads binary spike data file "fname" generated with BrainWare 
% "File | Save As | Spike Times as Binary"
% (c) Jan Schnupp, Feb 1999
% Modified by Igor Kagan: Sep 26, 2001

[f,message]=fopen(fname, 'r');
if f==-1,
	disp(message);
	return
end
numsets=0;
numsweeps=0;
totalsweeps=0;
totalspikes=0;
i=fread(f,1,'float32');
while ~isempty(i);

   switch i
   case (-2) % new dataset
	  numsets=numsets+1; 

     numsweeps=0;
     % read sweeplength
	  data(numsets).sweeplength=fread(f,1,'float32');
     % read stimulus parameters
     numparams=fread(f,1,'float32');
     data(numsets).stim=fread(f,numparams,'float32');
       
   case (-1) % new sweep
      numsweeps=numsweeps+1;

      totalsweeps=totalsweeps+1;
      data(numsets).sweep(numsweeps).spikes=[];

   otherwise % read spike time for next spike in current sweep

      data(numsets).sweep(numsweeps).spikes=...
			[data(numsets).sweep(numsweeps).spikes i];
      totalspikes=totalspikes+1;
   end;
   
   i=fread(f,1,'float32');
end;
fclose(f);
disp([fname ': ' sprintf('read %d sets, %d sweeps, %d spikes',...
   numsets, totalsweeps, totalspikes)])







